# NAME

WWW::SwaggerClient::Role - a Moose role for the Reputation CRM API

Move your app forward with the Reputation CRM API  To get your `API key`, visit [Reputation CRM](https://reputationcrm.com/settings/index/Reputation-Builder)  Your API Key can be found in Settings -> Reputation Builder -> Reputation Builder -> API Tab   [Download API SDK](https://reputationcrm.com/developers/documentation/v2/downloads)  [API Explorer](https://reputationcrm.com/developers/documentation/v2/explorer/) 

# VERSION

Automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 2.0.2
- Package version: 1.0.0
- Build package: io.swagger.codegen.languages.PerlClientCodegen

## A note on Moose

This role is the only component of the library that uses Moose. See
WWW::SwaggerClient::ApiFactory for non-Moosey usage.

# SYNOPSIS

The Perl Swagger Codegen project builds a library of Perl modules to interact with
a web service defined by a OpenAPI Specification. See below for how to build the
library.

This module provides an interface to the generated library. All the classes,
objects, and methods (well, not quite \*all\*, see below) are flattened into this
role.

        package MyApp;
        use Moose;
        with 'WWW::SwaggerClient::Role';

        package main;

        my $api = MyApp->new({ tokens => $tokens });

        my $pet = $api->get_pet_by_id(pet_id => $pet_id);


## Structure of the library

The library consists of a set of API classes, one for each endpoint. These APIs
implement the method calls available on each endpoint.

Additionally, there is a set of "object" classes, which represent the objects
returned by and sent to the methods on the endpoints.

An API factory class is provided, which builds instances of each endpoint API.

This Moose role flattens all the methods from the endpoint APIs onto the consuming
class. It also provides methods to retrieve the endpoint API objects, and the API
factory object, should you need it.

For documentation of all these methods, see AUTOMATIC DOCUMENTATION below.

## Configuring authentication

In the normal case, the OpenAPI Spec will describe what parameters are
required and where to put them. You just need to supply the tokens.

    my $tokens = {
        # basic
        username => $username,
        password => $password,

        # oauth
        access_token => $oauth_token,

        # keys
        $some_key => { token => $token,
                       prefix => $prefix,
                       in => $in,             # 'head||query',
                       },

        $another => { token => $token,
                      prefix => $prefix,
                      in => $in,              # 'head||query',
                      },
        ...,

        };

        my $api = MyApp->new({ tokens => $tokens });

Note these are all optional, as are `prefix` and `in`, and depend on the API
you are accessing. Usually `prefix` and `in` will be determined by the code generator from
the spec and you will not need to set them at run time. If not, `in` will
default to 'head' and `prefix` to the empty string.

The tokens will be placed in a L<WWW::SwaggerClient::Configuration> instance
as follows, but you don't need to know about this.

- `$cfg->{username}`

    String. The username for basic auth.

- `$cfg->{password}`

    String. The password for basic auth.

- `$cfg->{api_key}`

    Hashref. Keyed on the name of each key (there can be multiple tokens).

            $cfg->{api_key} = {
                    secretKey => 'aaaabbbbccccdddd',
                    anotherKey => '1111222233334444',
                    };

- `$cfg->{api_key_prefix}`

    Hashref. Keyed on the name of each key (there can be multiple tokens). Note not
    all api keys require a prefix.

            $cfg->{api_key_prefix} = {
                    secretKey => 'string',
                    anotherKey => 'same or some other string',
                    };

- `$cfg->{access_token}`

    String. The OAuth access token.

# METHODS

## `base_url`

The generated code has the `base_url` already set as a default value. This method
returns the current value of `base_url`.

## `api_factory`

Returns an API factory object. You probably won't need to call this directly.

        $self->api_factory('Pet'); # returns a WWW::SwaggerClient::PetApi instance

        $self->pet_api;            # the same

# MISSING METHODS

Most of the methods on the API are delegated to individual endpoint API objects
(e.g. Pet API, Store API, User API etc). Where different endpoint APIs use the
same method name (e.g. `new()`), these methods can't be delegated. So you need
to call `$api->pet_api->new()`.

In principle, every API is susceptible to the presence of a few, random, undelegatable
method names. In practice, because of the way method names are constructed, it's
unlikely in general that any methods will be undelegatable, except for:

        new()
        class_documentation()
        method_documentation()

To call these methods, you need to get a handle on the relevant object, either
by calling `$api->foo_api` or by retrieving an object, e.g.
`$api->get_pet_by_id(pet_id => $pet_id)`. They are class methods, so
you could also call them on class names.

# BUILDING YOUR LIBRARY

See the homepage `https://github.com/swagger-api/swagger-codegen` for full details.
But briefly, clone the git repository, build the codegen codebase, set up your build
config file, then run the API build script. You will need git, Java 7 or 8 and Apache
maven 3.0.3 or better already installed.

The config file should specify the project name for the generated library:

        {"moduleName":"WWW::MyProjectName"}

Your library files will be built under `WWW::MyProjectName`.

          $ git clone https://github.com/swagger-api/swagger-codegen.git
          $ cd swagger-codegen
          $ mvn package
          $ java -jar modules/swagger-codegen-cli/target/swagger-codegen-cli.jar generate \
    -i [URL or file path to JSON swagger API spec] \
    -l perl \
    -c /path/to/config/file.json \
    -o /path/to/output/folder

Bang, all done. Run the `autodoc` script in the `bin` directory to see the API
you just built.

# AUTOMATIC DOCUMENTATION

You can print out a summary of the generated API by running the included
`autodoc` script in the `bin` directory of your generated library. A few
output formats are supported:

          Usage: autodoc [OPTION]

    -w           wide format (default)
    -n           narrow format
    -p           POD format
    -H           HTML format
    -m           Markdown format
    -h           print this help message
    -c           your application class


The `-c` option allows you to load and inspect your own application. A dummy
namespace is used if you don't supply your own class.

# DOCUMENTATION FROM THE OpenAPI Spec

Additional documentation for each class and method may be provided by the Swagger
spec. If so, this is available via the `class_documentation()` and
`method_documentation()` methods on each generated object class, and the
`method_documentation()` method on the endpoint API classes:

        my $cmdoc = $api->pet_api->method_documentation->{$method_name};

        my $odoc = $api->get_pet_by_id->(pet_id => $pet_id)->class_documentation;
        my $omdoc = $api->get_pet_by_id->(pet_id => $pet_id)->method_documentation->{method_name};


Each of these calls returns a hashref with various useful pieces of information.

# LOAD THE MODULES

To load the API packages:
```perl
use WWW::SwaggerClient::CustomerApi;
use WWW::SwaggerClient::EmailSMSStatsApi;
use WWW::SwaggerClient::QueueApi;
use WWW::SwaggerClient::RescheduleApi;
use WWW::SwaggerClient::ReviewSitesApi;
use WWW::SwaggerClient::ReviewsApi;
use WWW::SwaggerClient::ReviewsStatsApi;
use WWW::SwaggerClient::SentLogApi;

```

To load the models:
```perl
use WWW::SwaggerClient::Object::Comment;
use WWW::SwaggerClient::Object::Customer;
use WWW::SwaggerClient::Object::CustomerWhoHaveNotResponded;
use WWW::SwaggerClient::Object::EmailSmsSentCount;
use WWW::SwaggerClient::Object::EmailSmsSentLimit;
use WWW::SwaggerClient::Object::Error;
use WWW::SwaggerClient::Object::OverallCompanyRating;
use WWW::SwaggerClient::Object::OverallRatingAndReviewCount;
use WWW::SwaggerClient::Object::Queue;
use WWW::SwaggerClient::Object::Review;
use WWW::SwaggerClient::Object::ReviewSites;
use WWW::SwaggerClient::Object::ReviewSitesRating;
use WWW::SwaggerClient::Object::ReviewSitesReputationChange;
use WWW::SwaggerClient::Object::ReviewSitesReviewCount;
use WWW::SwaggerClient::Object::SentLog;

````

# GETTING STARTED
Put the Perl SDK under the 'lib' folder in your project directory, then run the following
```perl
#!/usr/bin/perl
use lib 'lib';
use strict;
use warnings;
# load the API package
use WWW::SwaggerClient::CustomerApi;
use WWW::SwaggerClient::EmailSMSStatsApi;
use WWW::SwaggerClient::QueueApi;
use WWW::SwaggerClient::RescheduleApi;
use WWW::SwaggerClient::ReviewSitesApi;
use WWW::SwaggerClient::ReviewsApi;
use WWW::SwaggerClient::ReviewsStatsApi;
use WWW::SwaggerClient::SentLogApi;

# load the models
use WWW::SwaggerClient::Object::Comment;
use WWW::SwaggerClient::Object::Customer;
use WWW::SwaggerClient::Object::CustomerWhoHaveNotResponded;
use WWW::SwaggerClient::Object::EmailSmsSentCount;
use WWW::SwaggerClient::Object::EmailSmsSentLimit;
use WWW::SwaggerClient::Object::Error;
use WWW::SwaggerClient::Object::OverallCompanyRating;
use WWW::SwaggerClient::Object::OverallRatingAndReviewCount;
use WWW::SwaggerClient::Object::Queue;
use WWW::SwaggerClient::Object::Review;
use WWW::SwaggerClient::Object::ReviewSites;
use WWW::SwaggerClient::Object::ReviewSitesRating;
use WWW::SwaggerClient::Object::ReviewSitesReputationChange;
use WWW::SwaggerClient::Object::ReviewSitesReviewCount;
use WWW::SwaggerClient::Object::SentLog;

# for displaying the API response data
use Data::Dumper;
use WWW::SwaggerClient::;

my $api_instance = WWW::SwaggerClient::->new(

    # Configure API key authorization: api_key
    api_key => {'key' => 'YOUR_API_KEY'},
    # uncomment below to setup prefix (e.g. Bearer) for API key, if needed
    #api_key_prefix => {'key' => 'Bearer'},
);

my $companyid = 'companyid_example'; # string | Company ID
my $firstname = 'firstname_example'; # string | Customer First Name
my $lastname = 'lastname_example'; # string | Customer Last Name
my $sendtype = 'sendtype_example'; # string | Feedback / Review Requests Sending Method (1 = Send via Email, 2 = Send via SMS, 1,2 = Send via Email AND SMS) Allowed values: \"1\", \"2\", \"1,2\" 
my $email = 'email_example'; # string | Customer Email
my $mobile = 'mobile_example'; # string | Customer Mobile Phone #: The Mobile Phone # must be formatted in its international version. Eg: +33647523335 (+33 = Country Code for France). No leading Zero on Mobile Phone # usually (NOTE: some countries might a leading zero). Here is an excellent script for mobile number formatting: https://github.com/jackocnr/intl-tel-input 
my $address = 'address_example'; # string | Customer Postal Address
my $zipcode = 'zipcode_example'; # string | Customer Zipcode
my $city = 'city_example'; # string | Customer City
my $state = 'state_example'; # string | Customer State / Province / Region
my $country = 'country_example'; # string | Customer Country: has to be set to the name of the Country in its original language. Eg: Spain = EspaÃ±a. Download the sql file of all countries: https://reputationcrm.com/api/repcrm-api-docs/countries.txt 
my $language = 'language_example'; # string | Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages 
my $notes = 'notes_example'; # string | Additional Customer Notes

eval {
    my $result = $api_instance->create_customer_automatic(companyid => $companyid, firstname => $firstname, lastname => $lastname, sendtype => $sendtype, email => $email, mobile => $mobile, address => $address, zipcode => $zipcode, city => $city, state => $state, country => $country, language => $language, notes => $notes);
    print Dumper($result);
};
if ($@) {
    warn "Exception when calling CustomerApi->create_customer_automatic: $@\n";
}

```

# DOCUMENTATION FOR API ENDPOINTS

All URIs are relative to *https://reputationcrm.com/v2*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*CustomerApi* | [**create_customer_automatic**](docs/CustomerApi.md#create_customer_automatic) | **POST** /createCustomerAutomatic | Create a Customer AND a Feedback / Review Request Sequence with Automatic Scheduling (No delay before sending the First Feedback / Review Request)
*CustomerApi* | [**create_customer_automatic_with_delay_review_request**](docs/CustomerApi.md#create_customer_automatic_with_delay_review_request) | **POST** /createCustomerAutomaticWithDelayReviewRequest | Create a Customer AND a Feedback / Review Request Sequence with Automatic Scheduling (Set a Delay before sending the First Feedback / Review Request)
*CustomerApi* | [**create_customer_immediate_first_review_request**](docs/CustomerApi.md#create_customer_immediate_first_review_request) | **POST** /createCustomerImmediateFirstReviewRequest | Create a Customer AND Feedback / Review Requests
*CustomerApi* | [**create_customer_manual_schedule_one_review_request**](docs/CustomerApi.md#create_customer_manual_schedule_one_review_request) | **POST** /createCustomerManualScheduleOneReviewRequest | Create a Customer AND a one Feedback / Review Request (Manual Scheduling)
*CustomerApi* | [**delete_customer**](docs/CustomerApi.md#delete_customer) | **DELETE** /deleteCustomer | Delete ONE Customer record
*CustomerApi* | [**get_all_customers_bycompany_id**](docs/CustomerApi.md#get_all_customers_bycompany_id) | **GET** /getAllCustomersBycompanyId | Get Information on ALL Customers of a Company / Location / Feedback Page
*CustomerApi* | [**get_customers_who_have_not_yet_submitted_review**](docs/CustomerApi.md#get_customers_who_have_not_yet_submitted_review) | **GET** /getCustomersWhoHaveNotYetSubmittedReview | Get a list of Customers who have not yet submitted their Review / Feedback
*CustomerApi* | [**get_single_customer**](docs/CustomerApi.md#get_single_customer) | **GET** /getSingleCustomer | Get Information of ONE Customer
*CustomerApi* | [**update_customer**](docs/CustomerApi.md#update_customer) | **PUT** /updateCustomer | Update the record of ONE Customer
*EmailSMSStatsApi* | [**get_email_sms_sent_count**](docs/EmailSMSStatsApi.md#get_email_sms_sent_count) | **GET** /getEmailSmsSentCount | Email / SMS sent
*EmailSMSStatsApi* | [**get_email_sms_sent_limit**](docs/EmailSMSStatsApi.md#get_email_sms_sent_limit) | **GET** /getEmailSmsSentLimit | Email / SMS Limit
*QueueApi* | [**delete_queue_by_customer_id**](docs/QueueApi.md#delete_queue_by_customer_id) | **DELETE** /deleteQueueByCustomerId | Delete requests of a customer
*QueueApi* | [**delete_queue_bycompany_id**](docs/QueueApi.md#delete_queue_bycompany_id) | **DELETE** /deleteQueueBycompanyId | Delete requests of a company
*QueueApi* | [**get_queue_bycompany_id**](docs/QueueApi.md#get_queue_bycompany_id) | **GET** /getQueueBycompanyId | Get a customerâ€™s queue
*QueueApi* | [**get_single_customer_queue**](docs/QueueApi.md#get_single_customer_queue) | **GET** /getQueueByCustomerId | Get a customerâ€™s queue
*RescheduleApi* | [**reschedule_customer_automatic**](docs/RescheduleApi.md#reschedule_customer_automatic) | **POST** /rescheduleCustomerAutomatic | Reschedule Customer (Automatic)
*RescheduleApi* | [**reschedule_customer_immediate**](docs/RescheduleApi.md#reschedule_customer_immediate) | **POST** /rescheduleCustomerImmediate | Reschedule Customer (Send right away)
*RescheduleApi* | [**reschedule_manual_one_review_request**](docs/RescheduleApi.md#reschedule_manual_one_review_request) | **POST** /rescheduleManualOneReviewRequest | Reschedule Customer (Manual Schedule)
*ReviewSitesApi* | [**get_all_review_sites_by_user_name**](docs/ReviewSitesApi.md#get_all_review_sites_by_user_name) | **GET** /getAllReviewSitesByUserName | Get all review sites of an account
*ReviewSitesApi* | [**get_all_review_sites_bycompany_id**](docs/ReviewSitesApi.md#get_all_review_sites_bycompany_id) | **GET** /getAllReviewSitesBycompanyId | Get all review sites of a company
*ReviewsApi* | [**get_commentson_review**](docs/ReviewsApi.md#get_commentson_review) | **GET** /getCommentsonReview | Get review comments
*ReviewsApi* | [**get_reviews_by_company_id**](docs/ReviewsApi.md#get_reviews_by_company_id) | **GET** /getReviewsByCompanyID | Get X last reviews less than X days old of a company
*ReviewsApi* | [**get_reviews_by_company_id_and_rating**](docs/ReviewsApi.md#get_reviews_by_company_id_and_rating) | **GET** /getReviewsByCompanyIdAndRating | Get X last reviews that equal or over X stars of a company
*ReviewsApi* | [**get_reviews_by_company_id_and_review_site**](docs/ReviewsApi.md#get_reviews_by_company_id_and_review_site) | **GET** /getReviewsByCompanyIDAndReviewSite | Get X last reviews less than X days old of a review site of a company
*ReviewsApi* | [**get_reviews_by_company_id_rating_and_review_site**](docs/ReviewsApi.md#get_reviews_by_company_id_rating_and_review_site) | **GET** /getReviewsByCompanyIDRatingAndReviewSite | Get X last reviews that equal or over X stars of a review site of a company
*ReviewsApi* | [**get_reviews_by_user_name**](docs/ReviewsApi.md#get_reviews_by_user_name) | **GET** /getReviewsByUserName | Get X last reviews less than X days old of an account
*ReviewsApi* | [**get_reviews_by_user_name_and_rating**](docs/ReviewsApi.md#get_reviews_by_user_name_and_rating) | **GET** /getReviewsByUserNameAndRating | Get X last reviews that equal or over X stars of an account
*ReviewsApi* | [**get_reviews_by_user_name_and_review_site**](docs/ReviewsApi.md#get_reviews_by_user_name_and_review_site) | **GET** /getReviewsByUserNameAndReviewSite | Get X last reviews less than X days old of a review site of an account
*ReviewsApi* | [**get_reviews_by_user_name_rating_and_review_site**](docs/ReviewsApi.md#get_reviews_by_user_name_rating_and_review_site) | **GET** /getReviewsByUserNameRatingAndReviewSite | Get X last reviews that equal or over X stars of a review site of an account
*ReviewsApi* | [**post_comment_on_review**](docs/ReviewsApi.md#post_comment_on_review) | **POST** /postCommentOnReview | Comment on a Feedback / Review
*ReviewsStatsApi* | [**get_number_of_reviews_posted_in_last_days_by_company_id**](docs/ReviewsStatsApi.md#get_number_of_reviews_posted_in_last_days_by_company_id) | **GET** /getNumberOfReviewsPostedInLastDaysByCompanyId | Get total reviews received for each review site
*ReviewsStatsApi* | [**get_number_of_reviews_required_to_achieve5_star_by_company_id**](docs/ReviewsStatsApi.md#get_number_of_reviews_required_to_achieve5_star_by_company_id) | **GET** /getNumberOfReviewsRequiredToAchieve5StarByCompanyId | Get for ALL Review Sites the number of 5-star Feedback / Reviews needed to achieve a 5-star Customer Experience 
*ReviewsStatsApi* | [**get_overall_rating_and_review_count_for_platform_reviews_by_company_id**](docs/ReviewsStatsApi.md#get_overall_rating_and_review_count_for_platform_reviews_by_company_id) | **GET** /getOverallRatingAndReviewCountForPlatformReviewsByCompanyId | Get The Overall Rating and Total Review Count of a Company / Location for platform collected reviews  
*ReviewsStatsApi* | [**get_overall_rating_for_each_review_site_by_company_id**](docs/ReviewsStatsApi.md#get_overall_rating_for_each_review_site_by_company_id) | **GET** /getOverallRatingForEachReviewSiteByCompanyId | Get overall rating for each review site
*ReviewsStatsApi* | [**get_overall_rating_of_company_by_company_id**](docs/ReviewsStatsApi.md#get_overall_rating_of_company_by_company_id) | **GET** /getOverallRatingOfCompanyByCompanyId | Get The Overall Rating of a Company / Location / Feedback Page 
*ReviewsStatsApi* | [**get_overall_reputation_change_of_all_review_sites_by_company_id**](docs/ReviewsStatsApi.md#get_overall_reputation_change_of_all_review_sites_by_company_id) | **GET** /getOverallReputationChangeOfAllReviewSitesByCompanyId | Get the Overall Reputation Increase / Decrease of ALL Review Sites 
*ReviewsStatsApi* | [**get_total_reviews_received_for_each_review_site_by_company_id**](docs/ReviewsStatsApi.md#get_total_reviews_received_for_each_review_site_by_company_id) | **GET** /getTotalReviewsReceivedForEachReviewSiteByCompanyId | Get total reviews received for each review site
*SentLogApi* | [**get_sent_log_by_company_id**](docs/SentLogApi.md#get_sent_log_by_company_id) | **GET** /getSentLogByCompanyId | Get company&#39;s sent log
*SentLogApi* | [**get_sent_log_by_customer_id**](docs/SentLogApi.md#get_sent_log_by_customer_id) | **GET** /getSentLogByCustomerId | Get a customerâ€™s sent log


# DOCUMENTATION FOR MODELS
 - [WWW::SwaggerClient::Object::Comment](docs/Comment.md)
 - [WWW::SwaggerClient::Object::Customer](docs/Customer.md)
 - [WWW::SwaggerClient::Object::CustomerWhoHaveNotResponded](docs/CustomerWhoHaveNotResponded.md)
 - [WWW::SwaggerClient::Object::EmailSmsSentCount](docs/EmailSmsSentCount.md)
 - [WWW::SwaggerClient::Object::EmailSmsSentLimit](docs/EmailSmsSentLimit.md)
 - [WWW::SwaggerClient::Object::Error](docs/Error.md)
 - [WWW::SwaggerClient::Object::OverallCompanyRating](docs/OverallCompanyRating.md)
 - [WWW::SwaggerClient::Object::OverallRatingAndReviewCount](docs/OverallRatingAndReviewCount.md)
 - [WWW::SwaggerClient::Object::Queue](docs/Queue.md)
 - [WWW::SwaggerClient::Object::Review](docs/Review.md)
 - [WWW::SwaggerClient::Object::ReviewSites](docs/ReviewSites.md)
 - [WWW::SwaggerClient::Object::ReviewSitesRating](docs/ReviewSitesRating.md)
 - [WWW::SwaggerClient::Object::ReviewSitesReputationChange](docs/ReviewSitesReputationChange.md)
 - [WWW::SwaggerClient::Object::ReviewSitesReviewCount](docs/ReviewSitesReviewCount.md)
 - [WWW::SwaggerClient::Object::SentLog](docs/SentLog.md)


# DOCUMENTATION FOR AUTHORIZATION

## api_key

- **Type**: API key
- **API key parameter name**: key
- **Location**: HTTP header

