# WWW::SwaggerClient::EmailSMSStatsApi

## Load the API package
```perl
use WWW::SwaggerClient::Object::EmailSMSStatsApi;
```

All URIs are relative to *https://reputationcrm.com/v2*

Method | HTTP request | Description
------------- | ------------- | -------------
[**get_email_sms_sent_count**](EmailSMSStatsApi.md#get_email_sms_sent_count) | **GET** /getEmailSmsSentCount | Email / SMS sent
[**get_email_sms_sent_limit**](EmailSMSStatsApi.md#get_email_sms_sent_limit) | **GET** /getEmailSmsSentLimit | Email / SMS Limit


# **get_email_sms_sent_count**
> ARRAY[EmailSmsSentCount] get_email_sms_sent_count(username => $username)

Email / SMS sent

Email / SMS sent

### Example 
```perl
use Data::Dumper;
use WWW::SwaggerClient::EmailSMSStatsApi;
my $api_instance = WWW::SwaggerClient::EmailSMSStatsApi->new(

    # Configure API key authorization: api_key
    api_key => {'key' => 'YOUR_API_KEY'},
    # uncomment below to setup prefix (e.g. Bearer) for API key, if needed
    #api_key_prefix => {'key' => 'Bearer'},
);

my $username = 'username_example'; # string | User Name or Email address

eval { 
    my $result = $api_instance->get_email_sms_sent_count(username => $username);
    print Dumper($result);
};
if ($@) {
    warn "Exception when calling EmailSMSStatsApi->get_email_sms_sent_count: $@\n";
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **username** | **string**| User Name or Email address | 

### Return type

[**ARRAY[EmailSmsSentCount]**](EmailSmsSentCount.md)

### Authorization

[api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: application/x-www-form-urlencoded
 - **Accept**: application/json, application/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_email_sms_sent_limit**
> ARRAY[EmailSmsSentLimit] get_email_sms_sent_limit(username => $username)

Email / SMS Limit

Email / SMS Limit

### Example 
```perl
use Data::Dumper;
use WWW::SwaggerClient::EmailSMSStatsApi;
my $api_instance = WWW::SwaggerClient::EmailSMSStatsApi->new(

    # Configure API key authorization: api_key
    api_key => {'key' => 'YOUR_API_KEY'},
    # uncomment below to setup prefix (e.g. Bearer) for API key, if needed
    #api_key_prefix => {'key' => 'Bearer'},
);

my $username = 'username_example'; # string | User Name or Email address

eval { 
    my $result = $api_instance->get_email_sms_sent_limit(username => $username);
    print Dumper($result);
};
if ($@) {
    warn "Exception when calling EmailSMSStatsApi->get_email_sms_sent_limit: $@\n";
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **username** | **string**| User Name or Email address | 

### Return type

[**ARRAY[EmailSmsSentLimit]**](EmailSmsSentLimit.md)

### Authorization

[api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: application/x-www-form-urlencoded
 - **Accept**: application/json, application/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

