# WWW::SwaggerClient::QueueApi

## Load the API package
```perl
use WWW::SwaggerClient::Object::QueueApi;
```

All URIs are relative to *https://reputationcrm.com/v2*

Method | HTTP request | Description
------------- | ------------- | -------------
[**delete_queue_by_customer_id**](QueueApi.md#delete_queue_by_customer_id) | **DELETE** /deleteQueueByCustomerId | Delete requests of a customer
[**delete_queue_bycompany_id**](QueueApi.md#delete_queue_bycompany_id) | **DELETE** /deleteQueueBycompanyId | Delete requests of a company
[**get_queue_bycompany_id**](QueueApi.md#get_queue_bycompany_id) | **GET** /getQueueBycompanyId | Get a customerâ€™s queue
[**get_single_customer_queue**](QueueApi.md#get_single_customer_queue) | **GET** /getQueueByCustomerId | Get a customerâ€™s queue


# **delete_queue_by_customer_id**
> delete_queue_by_customer_id(customerid => $customerid)

Delete requests of a customer

Delete requests of a customer

### Example 
```perl
use Data::Dumper;
use WWW::SwaggerClient::QueueApi;
my $api_instance = WWW::SwaggerClient::QueueApi->new(

    # Configure API key authorization: api_key
    api_key => {'key' => 'YOUR_API_KEY'},
    # uncomment below to setup prefix (e.g. Bearer) for API key, if needed
    #api_key_prefix => {'key' => 'Bearer'},
);

my $customerid = 'customerid_example'; # string | Customer ID

eval { 
    $api_instance->delete_queue_by_customer_id(customerid => $customerid);
};
if ($@) {
    warn "Exception when calling QueueApi->delete_queue_by_customer_id: $@\n";
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **customerid** | **string**| Customer ID | 

### Return type

void (empty response body)

### Authorization

[api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: application/x-www-form-urlencoded
 - **Accept**: application/json, application/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **delete_queue_bycompany_id**
> delete_queue_bycompany_id(companyid => $companyid)

Delete requests of a company

Delete requests of a company

### Example 
```perl
use Data::Dumper;
use WWW::SwaggerClient::QueueApi;
my $api_instance = WWW::SwaggerClient::QueueApi->new(

    # Configure API key authorization: api_key
    api_key => {'key' => 'YOUR_API_KEY'},
    # uncomment below to setup prefix (e.g. Bearer) for API key, if needed
    #api_key_prefix => {'key' => 'Bearer'},
);

my $companyid = 'companyid_example'; # string | Company ID

eval { 
    $api_instance->delete_queue_bycompany_id(companyid => $companyid);
};
if ($@) {
    warn "Exception when calling QueueApi->delete_queue_bycompany_id: $@\n";
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **companyid** | **string**| Company ID | 

### Return type

void (empty response body)

### Authorization

[api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: application/x-www-form-urlencoded
 - **Accept**: application/json, application/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_queue_bycompany_id**
> ARRAY[Queue] get_queue_bycompany_id(companyid => $companyid)

Get a customerâ€™s queue

Get a customerâ€™s queue

### Example 
```perl
use Data::Dumper;
use WWW::SwaggerClient::QueueApi;
my $api_instance = WWW::SwaggerClient::QueueApi->new(

    # Configure API key authorization: api_key
    api_key => {'key' => 'YOUR_API_KEY'},
    # uncomment below to setup prefix (e.g. Bearer) for API key, if needed
    #api_key_prefix => {'key' => 'Bearer'},
);

my $companyid = 'companyid_example'; # string | Company ID

eval { 
    my $result = $api_instance->get_queue_bycompany_id(companyid => $companyid);
    print Dumper($result);
};
if ($@) {
    warn "Exception when calling QueueApi->get_queue_bycompany_id: $@\n";
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **companyid** | **string**| Company ID | 

### Return type

[**ARRAY[Queue]**](Queue.md)

### Authorization

[api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: application/x-www-form-urlencoded
 - **Accept**: application/json, application/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_single_customer_queue**
> ARRAY[Queue] get_single_customer_queue(customerid => $customerid)

Get a customerâ€™s queue

Get a customerâ€™s queue

### Example 
```perl
use Data::Dumper;
use WWW::SwaggerClient::QueueApi;
my $api_instance = WWW::SwaggerClient::QueueApi->new(

    # Configure API key authorization: api_key
    api_key => {'key' => 'YOUR_API_KEY'},
    # uncomment below to setup prefix (e.g. Bearer) for API key, if needed
    #api_key_prefix => {'key' => 'Bearer'},
);

my $customerid = 'customerid_example'; # string | Customer ID

eval { 
    my $result = $api_instance->get_single_customer_queue(customerid => $customerid);
    print Dumper($result);
};
if ($@) {
    warn "Exception when calling QueueApi->get_single_customer_queue: $@\n";
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **customerid** | **string**| Customer ID | 

### Return type

[**ARRAY[Queue]**](Queue.md)

### Authorization

[api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: application/x-www-form-urlencoded
 - **Accept**: application/json, application/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

