# WWW::SwaggerClient::RescheduleApi

## Load the API package
```perl
use WWW::SwaggerClient::Object::RescheduleApi;
```

All URIs are relative to *https://reputationcrm.com/v2*

Method | HTTP request | Description
------------- | ------------- | -------------
[**reschedule_customer_automatic**](RescheduleApi.md#reschedule_customer_automatic) | **POST** /rescheduleCustomerAutomatic | Reschedule Customer (Automatic)
[**reschedule_customer_immediate**](RescheduleApi.md#reschedule_customer_immediate) | **POST** /rescheduleCustomerImmediate | Reschedule Customer (Send right away)
[**reschedule_manual_one_review_request**](RescheduleApi.md#reschedule_manual_one_review_request) | **POST** /rescheduleManualOneReviewRequest | Reschedule Customer (Manual Schedule)


# **reschedule_customer_automatic**
> reschedule_customer_automatic(customerid => $customerid, language => $language)

Reschedule Customer (Automatic)

Reschedule Customer (Automatic) 

### Example 
```perl
use Data::Dumper;
use WWW::SwaggerClient::RescheduleApi;
my $api_instance = WWW::SwaggerClient::RescheduleApi->new(

    # Configure API key authorization: api_key
    api_key => {'key' => 'YOUR_API_KEY'},
    # uncomment below to setup prefix (e.g. Bearer) for API key, if needed
    #api_key_prefix => {'key' => 'Bearer'},
);

my $customerid = 'customerid_example'; # string | Customer ID
my $language = 'language_example'; # string | Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages 

eval { 
    $api_instance->reschedule_customer_automatic(customerid => $customerid, language => $language);
};
if ($@) {
    warn "Exception when calling RescheduleApi->reschedule_customer_automatic: $@\n";
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **customerid** | **string**| Customer ID | 
 **language** | **string**| Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages  | 

### Return type

void (empty response body)

### Authorization

[api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: application/x-www-form-urlencoded
 - **Accept**: application/json, application/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **reschedule_customer_immediate**
> reschedule_customer_immediate(customerid => $customerid, language => $language)

Reschedule Customer (Send right away)

Reschedule Customer (Send right away) 

### Example 
```perl
use Data::Dumper;
use WWW::SwaggerClient::RescheduleApi;
my $api_instance = WWW::SwaggerClient::RescheduleApi->new(

    # Configure API key authorization: api_key
    api_key => {'key' => 'YOUR_API_KEY'},
    # uncomment below to setup prefix (e.g. Bearer) for API key, if needed
    #api_key_prefix => {'key' => 'Bearer'},
);

my $customerid = 'customerid_example'; # string | Customer ID
my $language = 'language_example'; # string | Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages 

eval { 
    $api_instance->reschedule_customer_immediate(customerid => $customerid, language => $language);
};
if ($@) {
    warn "Exception when calling RescheduleApi->reschedule_customer_immediate: $@\n";
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **customerid** | **string**| Customer ID | 
 **language** | **string**| Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages  | 

### Return type

void (empty response body)

### Authorization

[api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: application/x-www-form-urlencoded
 - **Accept**: application/json, application/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **reschedule_manual_one_review_request**
> reschedule_manual_one_review_request(customerid => $customerid, language => $language, scheduledate => $scheduledate, scheduletime => $scheduletime, emailnumber => $emailnumber, smsnumber => $smsnumber)

Reschedule Customer (Manual Schedule)

Reschedule Customer (Manual Schedule) 

### Example 
```perl
use Data::Dumper;
use WWW::SwaggerClient::RescheduleApi;
my $api_instance = WWW::SwaggerClient::RescheduleApi->new(

    # Configure API key authorization: api_key
    api_key => {'key' => 'YOUR_API_KEY'},
    # uncomment below to setup prefix (e.g. Bearer) for API key, if needed
    #api_key_prefix => {'key' => 'Bearer'},
);

my $customerid = 'customerid_example'; # string | Customer ID
my $language = 'language_example'; # string | Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages 
my $scheduledate = 'scheduledate_example'; # string | Schedule date (yyyy/mm/dd) 
my $scheduletime = 'scheduletime_example'; # string | Schedule time (HH:MM 24 hours format) 
my $emailnumber = 'emailnumber_example'; # string | Set which Email Feedback / Requests will be sent (Allowed values: \"1\", \"2\", \"3\") 
my $smsnumber = 'smsnumber_example'; # string | Set which SMS Feedback / Requests will be sent (Allowed values: \"1\", \"2\", \"3\") 

eval { 
    $api_instance->reschedule_manual_one_review_request(customerid => $customerid, language => $language, scheduledate => $scheduledate, scheduletime => $scheduletime, emailnumber => $emailnumber, smsnumber => $smsnumber);
};
if ($@) {
    warn "Exception when calling RescheduleApi->reschedule_manual_one_review_request: $@\n";
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **customerid** | **string**| Customer ID | 
 **language** | **string**| Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages  | 
 **scheduledate** | **string**| Schedule date (yyyy/mm/dd)  | 
 **scheduletime** | **string**| Schedule time (HH:MM 24 hours format)  | 
 **emailnumber** | **string**| Set which Email Feedback / Requests will be sent (Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;3\&quot;)  | [default to 1]
 **smsnumber** | **string**| Set which SMS Feedback / Requests will be sent (Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;3\&quot;)  | [default to 1]

### Return type

void (empty response body)

### Authorization

[api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: application/x-www-form-urlencoded
 - **Accept**: application/json, application/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

