# WWW::SwaggerClient::ReviewSitesApi

## Load the API package
```perl
use WWW::SwaggerClient::Object::ReviewSitesApi;
```

All URIs are relative to *https://reputationcrm.com/v2*

Method | HTTP request | Description
------------- | ------------- | -------------
[**get_all_review_sites_by_user_name**](ReviewSitesApi.md#get_all_review_sites_by_user_name) | **GET** /getAllReviewSitesByUserName | Get all review sites of an account
[**get_all_review_sites_bycompany_id**](ReviewSitesApi.md#get_all_review_sites_bycompany_id) | **GET** /getAllReviewSitesBycompanyId | Get all review sites of a company


# **get_all_review_sites_by_user_name**
> ARRAY[ReviewSites] get_all_review_sites_by_user_name(username => $username)

Get all review sites of an account

Get all review sites of an account

### Example 
```perl
use Data::Dumper;
use WWW::SwaggerClient::ReviewSitesApi;
my $api_instance = WWW::SwaggerClient::ReviewSitesApi->new(

    # Configure API key authorization: api_key
    api_key => {'key' => 'YOUR_API_KEY'},
    # uncomment below to setup prefix (e.g. Bearer) for API key, if needed
    #api_key_prefix => {'key' => 'Bearer'},
);

my $username = 'username_example'; # string | User Name or Email address

eval { 
    my $result = $api_instance->get_all_review_sites_by_user_name(username => $username);
    print Dumper($result);
};
if ($@) {
    warn "Exception when calling ReviewSitesApi->get_all_review_sites_by_user_name: $@\n";
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **username** | **string**| User Name or Email address | 

### Return type

[**ARRAY[ReviewSites]**](ReviewSites.md)

### Authorization

[api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: application/x-www-form-urlencoded
 - **Accept**: application/json, application/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_all_review_sites_bycompany_id**
> ARRAY[ReviewSites] get_all_review_sites_bycompany_id(companyid => $companyid)

Get all review sites of a company

Get all review sites of a company

### Example 
```perl
use Data::Dumper;
use WWW::SwaggerClient::ReviewSitesApi;
my $api_instance = WWW::SwaggerClient::ReviewSitesApi->new(

    # Configure API key authorization: api_key
    api_key => {'key' => 'YOUR_API_KEY'},
    # uncomment below to setup prefix (e.g. Bearer) for API key, if needed
    #api_key_prefix => {'key' => 'Bearer'},
);

my $companyid = 'companyid_example'; # string | Company ID

eval { 
    my $result = $api_instance->get_all_review_sites_bycompany_id(companyid => $companyid);
    print Dumper($result);
};
if ($@) {
    warn "Exception when calling ReviewSitesApi->get_all_review_sites_bycompany_id: $@\n";
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **companyid** | **string**| Company ID | 

### Return type

[**ARRAY[ReviewSites]**](ReviewSites.md)

### Authorization

[api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: application/x-www-form-urlencoded
 - **Accept**: application/json, application/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

