# WWW::SwaggerClient::ReviewsStatsApi

## Load the API package
```perl
use WWW::SwaggerClient::Object::ReviewsStatsApi;
```

All URIs are relative to *https://reputationcrm.com/v2*

Method | HTTP request | Description
------------- | ------------- | -------------
[**get_number_of_reviews_posted_in_last_days_by_company_id**](ReviewsStatsApi.md#get_number_of_reviews_posted_in_last_days_by_company_id) | **GET** /getNumberOfReviewsPostedInLastDaysByCompanyId | Get total reviews received for each review site
[**get_number_of_reviews_required_to_achieve5_star_by_company_id**](ReviewsStatsApi.md#get_number_of_reviews_required_to_achieve5_star_by_company_id) | **GET** /getNumberOfReviewsRequiredToAchieve5StarByCompanyId | Get for ALL Review Sites the number of 5-star Feedback / Reviews needed to achieve a 5-star Customer Experience 
[**get_overall_rating_and_review_count_for_platform_reviews_by_company_id**](ReviewsStatsApi.md#get_overall_rating_and_review_count_for_platform_reviews_by_company_id) | **GET** /getOverallRatingAndReviewCountForPlatformReviewsByCompanyId | Get The Overall Rating and Total Review Count of a Company / Location for platform collected reviews  
[**get_overall_rating_for_each_review_site_by_company_id**](ReviewsStatsApi.md#get_overall_rating_for_each_review_site_by_company_id) | **GET** /getOverallRatingForEachReviewSiteByCompanyId | Get overall rating for each review site
[**get_overall_rating_of_company_by_company_id**](ReviewsStatsApi.md#get_overall_rating_of_company_by_company_id) | **GET** /getOverallRatingOfCompanyByCompanyId | Get The Overall Rating of a Company / Location / Feedback Page 
[**get_overall_reputation_change_of_all_review_sites_by_company_id**](ReviewsStatsApi.md#get_overall_reputation_change_of_all_review_sites_by_company_id) | **GET** /getOverallReputationChangeOfAllReviewSitesByCompanyId | Get the Overall Reputation Increase / Decrease of ALL Review Sites 
[**get_total_reviews_received_for_each_review_site_by_company_id**](ReviewsStatsApi.md#get_total_reviews_received_for_each_review_site_by_company_id) | **GET** /getTotalReviewsReceivedForEachReviewSiteByCompanyId | Get total reviews received for each review site


# **get_number_of_reviews_posted_in_last_days_by_company_id**
> ARRAY[ReviewSitesReviewCount] get_number_of_reviews_posted_in_last_days_by_company_id(companyid => $companyid, last_how_many_days => $last_how_many_days)

Get total reviews received for each review site

Get total reviews received for each review site

### Example 
```perl
use Data::Dumper;
use WWW::SwaggerClient::ReviewsStatsApi;
my $api_instance = WWW::SwaggerClient::ReviewsStatsApi->new(

    # Configure API key authorization: api_key
    api_key => {'key' => 'YOUR_API_KEY'},
    # uncomment below to setup prefix (e.g. Bearer) for API key, if needed
    #api_key_prefix => {'key' => 'Bearer'},
);

my $companyid = 'companyid_example'; # string | Company ID
my $last_how_many_days = 'last_how_many_days_example'; # string | Last how many days

eval { 
    my $result = $api_instance->get_number_of_reviews_posted_in_last_days_by_company_id(companyid => $companyid, last_how_many_days => $last_how_many_days);
    print Dumper($result);
};
if ($@) {
    warn "Exception when calling ReviewsStatsApi->get_number_of_reviews_posted_in_last_days_by_company_id: $@\n";
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **companyid** | **string**| Company ID | 
 **last_how_many_days** | **string**| Last how many days | 

### Return type

[**ARRAY[ReviewSitesReviewCount]**](ReviewSitesReviewCount.md)

### Authorization

[api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: application/x-www-form-urlencoded
 - **Accept**: application/json, application/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_number_of_reviews_required_to_achieve5_star_by_company_id**
> ARRAY[ReviewSitesReviewCount] get_number_of_reviews_required_to_achieve5_star_by_company_id(companyid => $companyid)

Get for ALL Review Sites the number of 5-star Feedback / Reviews needed to achieve a 5-star Customer Experience 

This API call returns for each Review Site of a Company / Location / Feedback Page, the total number of 5-star Feedback / Reviews that the Company / Location needs, to achieve a 5-star Customer Experience. (NOTE: Most Review Sites display a 5-star image when the Overall Rating of a Company / Location is above 4.51. We decided to work as they do and we display a 5-star image for any Overall Rating above 4.51). URL: https://reputationcrm.com/reputation-control    Please refer this image for more information   https://reputationcrm.com/api/repcrm-api-img/NumberOfReviewsRequiredToAchieve5Star.jpg 

### Example 
```perl
use Data::Dumper;
use WWW::SwaggerClient::ReviewsStatsApi;
my $api_instance = WWW::SwaggerClient::ReviewsStatsApi->new(

    # Configure API key authorization: api_key
    api_key => {'key' => 'YOUR_API_KEY'},
    # uncomment below to setup prefix (e.g. Bearer) for API key, if needed
    #api_key_prefix => {'key' => 'Bearer'},
);

my $companyid = 'companyid_example'; # string | Company ID

eval { 
    my $result = $api_instance->get_number_of_reviews_required_to_achieve5_star_by_company_id(companyid => $companyid);
    print Dumper($result);
};
if ($@) {
    warn "Exception when calling ReviewsStatsApi->get_number_of_reviews_required_to_achieve5_star_by_company_id: $@\n";
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **companyid** | **string**| Company ID | 

### Return type

[**ARRAY[ReviewSitesReviewCount]**](ReviewSitesReviewCount.md)

### Authorization

[api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: application/x-www-form-urlencoded
 - **Accept**: application/json, application/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_overall_rating_and_review_count_for_platform_reviews_by_company_id**
> ARRAY[OverallRatingAndReviewCount] get_overall_rating_and_review_count_for_platform_reviews_by_company_id(companyid => $companyid)

Get The Overall Rating and Total Review Count of a Company / Location for platform collected reviews  

Get The Overall Rating and Total Review Count of a Company / Location for platform collected reviews. The number (from 1.00 to 5.00) includes only platform collected reviews.

### Example 
```perl
use Data::Dumper;
use WWW::SwaggerClient::ReviewsStatsApi;
my $api_instance = WWW::SwaggerClient::ReviewsStatsApi->new(

    # Configure API key authorization: api_key
    api_key => {'key' => 'YOUR_API_KEY'},
    # uncomment below to setup prefix (e.g. Bearer) for API key, if needed
    #api_key_prefix => {'key' => 'Bearer'},
);

my $companyid = 'companyid_example'; # string | Company ID

eval { 
    my $result = $api_instance->get_overall_rating_and_review_count_for_platform_reviews_by_company_id(companyid => $companyid);
    print Dumper($result);
};
if ($@) {
    warn "Exception when calling ReviewsStatsApi->get_overall_rating_and_review_count_for_platform_reviews_by_company_id: $@\n";
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **companyid** | **string**| Company ID | 

### Return type

[**ARRAY[OverallRatingAndReviewCount]**](OverallRatingAndReviewCount.md)

### Authorization

[api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: application/x-www-form-urlencoded
 - **Accept**: application/json, application/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_overall_rating_for_each_review_site_by_company_id**
> ARRAY[ReviewSitesRating] get_overall_rating_for_each_review_site_by_company_id(companyid => $companyid)

Get overall rating for each review site

Get overall rating for each review site

### Example 
```perl
use Data::Dumper;
use WWW::SwaggerClient::ReviewsStatsApi;
my $api_instance = WWW::SwaggerClient::ReviewsStatsApi->new(

    # Configure API key authorization: api_key
    api_key => {'key' => 'YOUR_API_KEY'},
    # uncomment below to setup prefix (e.g. Bearer) for API key, if needed
    #api_key_prefix => {'key' => 'Bearer'},
);

my $companyid = 'companyid_example'; # string | Company ID

eval { 
    my $result = $api_instance->get_overall_rating_for_each_review_site_by_company_id(companyid => $companyid);
    print Dumper($result);
};
if ($@) {
    warn "Exception when calling ReviewsStatsApi->get_overall_rating_for_each_review_site_by_company_id: $@\n";
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **companyid** | **string**| Company ID | 

### Return type

[**ARRAY[ReviewSitesRating]**](ReviewSitesRating.md)

### Authorization

[api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: application/x-www-form-urlencoded
 - **Accept**: application/json, application/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_overall_rating_of_company_by_company_id**
> ARRAY[OverallCompanyRating] get_overall_rating_of_company_by_company_id(companyid => $companyid)

Get The Overall Rating of a Company / Location / Feedback Page 

This API call returns the Overall Rating of a Company / Location / Feedback Page. The number (from 1.00 to 5.00) includes all Feedback / Reviews of a Company / Location / Feedback Page. URL: https://reputationcrm.com/reputation-control    Please refer https://reputationcrm.com/api/repcrm-api-img/OverallCompanyRating.jpg for more information 

### Example 
```perl
use Data::Dumper;
use WWW::SwaggerClient::ReviewsStatsApi;
my $api_instance = WWW::SwaggerClient::ReviewsStatsApi->new(

    # Configure API key authorization: api_key
    api_key => {'key' => 'YOUR_API_KEY'},
    # uncomment below to setup prefix (e.g. Bearer) for API key, if needed
    #api_key_prefix => {'key' => 'Bearer'},
);

my $companyid = 'companyid_example'; # string | Company ID

eval { 
    my $result = $api_instance->get_overall_rating_of_company_by_company_id(companyid => $companyid);
    print Dumper($result);
};
if ($@) {
    warn "Exception when calling ReviewsStatsApi->get_overall_rating_of_company_by_company_id: $@\n";
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **companyid** | **string**| Company ID | 

### Return type

[**ARRAY[OverallCompanyRating]**](OverallCompanyRating.md)

### Authorization

[api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: application/x-www-form-urlencoded
 - **Accept**: application/json, application/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_overall_reputation_change_of_all_review_sites_by_company_id**
> ARRAY[ReviewSitesReputationChange] get_overall_reputation_change_of_all_review_sites_by_company_id(companyid => $companyid)

Get the Overall Reputation Increase / Decrease of ALL Review Sites 

This API call returns for each Review Site of a Company / Location / Feedback Page, the Overall Reputation Increase / Decrease of the last 30 days compared to the previous month (31-60 days). 0 means no change: most likely, no new Feedback / Reviews were posted in the past 60 days, or the same number of Feedback / Reviews were posted in the last 30 days compared to the last 31-60 days period. A negative percentage means that the Overall Reputation has suffered. Finally, a positive percentage means an improvement in the Overall Reputation of the Company / Location / Feedback Page. URL: https://reputationcrm.com/reputation-control     Please refer https://reputationcrm.com/api/repcrm-api-img/ReputationChangeInTheLastMonth.jpg for more information 

### Example 
```perl
use Data::Dumper;
use WWW::SwaggerClient::ReviewsStatsApi;
my $api_instance = WWW::SwaggerClient::ReviewsStatsApi->new(

    # Configure API key authorization: api_key
    api_key => {'key' => 'YOUR_API_KEY'},
    # uncomment below to setup prefix (e.g. Bearer) for API key, if needed
    #api_key_prefix => {'key' => 'Bearer'},
);

my $companyid = 'companyid_example'; # string | Company ID

eval { 
    my $result = $api_instance->get_overall_reputation_change_of_all_review_sites_by_company_id(companyid => $companyid);
    print Dumper($result);
};
if ($@) {
    warn "Exception when calling ReviewsStatsApi->get_overall_reputation_change_of_all_review_sites_by_company_id: $@\n";
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **companyid** | **string**| Company ID | 

### Return type

[**ARRAY[ReviewSitesReputationChange]**](ReviewSitesReputationChange.md)

### Authorization

[api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: application/x-www-form-urlencoded
 - **Accept**: application/json, application/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_total_reviews_received_for_each_review_site_by_company_id**
> ARRAY[ReviewSitesReviewCount] get_total_reviews_received_for_each_review_site_by_company_id(companyid => $companyid)

Get total reviews received for each review site

Get total reviews received for each review site

### Example 
```perl
use Data::Dumper;
use WWW::SwaggerClient::ReviewsStatsApi;
my $api_instance = WWW::SwaggerClient::ReviewsStatsApi->new(

    # Configure API key authorization: api_key
    api_key => {'key' => 'YOUR_API_KEY'},
    # uncomment below to setup prefix (e.g. Bearer) for API key, if needed
    #api_key_prefix => {'key' => 'Bearer'},
);

my $companyid = 'companyid_example'; # string | Company ID

eval { 
    my $result = $api_instance->get_total_reviews_received_for_each_review_site_by_company_id(companyid => $companyid);
    print Dumper($result);
};
if ($@) {
    warn "Exception when calling ReviewsStatsApi->get_total_reviews_received_for_each_review_site_by_company_id: $@\n";
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **companyid** | **string**| Company ID | 

### Return type

[**ARRAY[ReviewSitesReviewCount]**](ReviewSitesReviewCount.md)

### Authorization

[api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: application/x-www-form-urlencoded
 - **Accept**: application/json, application/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

