# WWW::SwaggerClient::SentLogApi

## Load the API package
```perl
use WWW::SwaggerClient::Object::SentLogApi;
```

All URIs are relative to *https://reputationcrm.com/v2*

Method | HTTP request | Description
------------- | ------------- | -------------
[**get_sent_log_by_company_id**](SentLogApi.md#get_sent_log_by_company_id) | **GET** /getSentLogByCompanyId | Get company&#39;s sent log
[**get_sent_log_by_customer_id**](SentLogApi.md#get_sent_log_by_customer_id) | **GET** /getSentLogByCustomerId | Get a customerâ€™s sent log


# **get_sent_log_by_company_id**
> ARRAY[SentLog] get_sent_log_by_company_id(companyid => $companyid)

Get company's sent log

Get company's sent log

### Example 
```perl
use Data::Dumper;
use WWW::SwaggerClient::SentLogApi;
my $api_instance = WWW::SwaggerClient::SentLogApi->new(

    # Configure API key authorization: api_key
    api_key => {'key' => 'YOUR_API_KEY'},
    # uncomment below to setup prefix (e.g. Bearer) for API key, if needed
    #api_key_prefix => {'key' => 'Bearer'},
);

my $companyid = 'companyid_example'; # string | Company ID

eval { 
    my $result = $api_instance->get_sent_log_by_company_id(companyid => $companyid);
    print Dumper($result);
};
if ($@) {
    warn "Exception when calling SentLogApi->get_sent_log_by_company_id: $@\n";
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **companyid** | **string**| Company ID | 

### Return type

[**ARRAY[SentLog]**](SentLog.md)

### Authorization

[api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: application/x-www-form-urlencoded
 - **Accept**: application/json, application/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_sent_log_by_customer_id**
> ARRAY[SentLog] get_sent_log_by_customer_id(customerid => $customerid)

Get a customerâ€™s sent log

Get a customerâ€™s sent log

### Example 
```perl
use Data::Dumper;
use WWW::SwaggerClient::SentLogApi;
my $api_instance = WWW::SwaggerClient::SentLogApi->new(

    # Configure API key authorization: api_key
    api_key => {'key' => 'YOUR_API_KEY'},
    # uncomment below to setup prefix (e.g. Bearer) for API key, if needed
    #api_key_prefix => {'key' => 'Bearer'},
);

my $customerid = 'customerid_example'; # string | Customer ID

eval { 
    my $result = $api_instance->get_sent_log_by_customer_id(customerid => $customerid);
    print Dumper($result);
};
if ($@) {
    warn "Exception when calling SentLogApi->get_sent_log_by_customer_id: $@\n";
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **customerid** | **string**| Customer ID | 

### Return type

[**ARRAY[SentLog]**](SentLog.md)

### Authorization

[api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: application/x-www-form-urlencoded
 - **Accept**: application/json, application/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

