=begin comment

Reputation CRM API

Move your app forward with the Reputation CRM API  To get your `API key`, visit [Reputation CRM](https://reputationcrm.com/settings/index/Reputation-Builder)  Your API Key can be found in Settings -> Reputation Builder -> Reputation Builder -> API Tab   [Download API SDK](https://reputationcrm.com/developers/documentation/v2/downloads)  [API Explorer](https://reputationcrm.com/developers/documentation/v2/explorer/) 

OpenAPI spec version: 2.0.2
Contact: support@reputationcrm.com
Generated by: https://github.com/swagger-api/swagger-codegen.git

=end comment

=cut

#
# NOTE: This class is auto generated by the swagger code generator program. 
# Do not edit the class manually.
# Ref: https://github.com/swagger-api/swagger-codegen
#
package WWW::SwaggerClient::CustomerApi;

require 5.6.0;
use strict;
use warnings;
use utf8; 
use Exporter;
use Carp qw( croak );
use Log::Any qw($log);

use WWW::SwaggerClient::ApiClient;

use base "Class::Data::Inheritable";

__PACKAGE__->mk_classdata('method_documentation' => {});

sub new {
    my $class = shift;
    my $api_client;

    if ($_[0] && ref $_[0] && ref $_[0] eq 'WWW::SwaggerClient::ApiClient' ) {
        $api_client = $_[0];
    } else {
        $api_client = WWW::SwaggerClient::ApiClient->new(@_);
    }

    bless { api_client => $api_client }, $class;

}


#
# create_customer_automatic
#
# Create a Customer AND a Feedback / Review Request Sequence with Automatic Scheduling (No delay before sending the First Feedback / Review Request)
# 
# @param string $companyid Company ID (required)
# @param string $firstname Customer First Name (required)
# @param string $lastname Customer Last Name (required)
# @param string $sendtype Feedback / Review Requests Sending Method (1 &#x3D; Send via Email, 2 &#x3D; Send via SMS, 1,2 &#x3D; Send via Email AND SMS) Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;1,2\&quot;  (required)
# @param string $email Customer Email (optional)
# @param string $mobile Customer Mobile Phone #: The Mobile Phone # must be formatted in its international version. Eg: +33647523335 (+33 &#x3D; Country Code for France). No leading Zero on Mobile Phone # usually (NOTE: some countries might a leading zero). Here is an excellent script for mobile number formatting: https://github.com/jackocnr/intl-tel-input  (optional)
# @param string $address Customer Postal Address (optional)
# @param string $zipcode Customer Zipcode (optional)
# @param string $city Customer City (optional)
# @param string $state Customer State / Province / Region (optional)
# @param string $country Customer Country: has to be set to the name of the Country in its original language. Eg: Spain &#x3D; EspaÃ±a. Download the sql file of all countries: https://reputationcrm.com/api/repcrm-api-docs/countries.txt  (optional)
# @param string $language Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages  (optional)
# @param string $notes Additional Customer Notes (optional)
{
    my $params = {
    'companyid' => {
        data_type => 'string',
        description => 'Company ID',
        required => '1',
    },
    'firstname' => {
        data_type => 'string',
        description => 'Customer First Name',
        required => '1',
    },
    'lastname' => {
        data_type => 'string',
        description => 'Customer Last Name',
        required => '1',
    },
    'sendtype' => {
        data_type => 'string',
        description => 'Feedback / Review Requests Sending Method (1 &#x3D; Send via Email, 2 &#x3D; Send via SMS, 1,2 &#x3D; Send via Email AND SMS) Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;1,2\&quot; ',
        required => '1',
    },
    'email' => {
        data_type => 'string',
        description => 'Customer Email',
        required => '0',
    },
    'mobile' => {
        data_type => 'string',
        description => 'Customer Mobile Phone #: The Mobile Phone # must be formatted in its international version. Eg: +33647523335 (+33 &#x3D; Country Code for France). No leading Zero on Mobile Phone # usually (NOTE: some countries might a leading zero). Here is an excellent script for mobile number formatting: https://github.com/jackocnr/intl-tel-input ',
        required => '0',
    },
    'address' => {
        data_type => 'string',
        description => 'Customer Postal Address',
        required => '0',
    },
    'zipcode' => {
        data_type => 'string',
        description => 'Customer Zipcode',
        required => '0',
    },
    'city' => {
        data_type => 'string',
        description => 'Customer City',
        required => '0',
    },
    'state' => {
        data_type => 'string',
        description => 'Customer State / Province / Region',
        required => '0',
    },
    'country' => {
        data_type => 'string',
        description => 'Customer Country: has to be set to the name of the Country in its original language. Eg: Spain &#x3D; EspaÃ±a. Download the sql file of all countries: https://reputationcrm.com/api/repcrm-api-docs/countries.txt ',
        required => '0',
    },
    'language' => {
        data_type => 'string',
        description => 'Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages ',
        required => '0',
    },
    'notes' => {
        data_type => 'string',
        description => 'Additional Customer Notes',
        required => '0',
    },
    };
    __PACKAGE__->method_documentation->{ 'create_customer_automatic' } = { 
    	summary => 'Create a Customer AND a Feedback / Review Request Sequence with Automatic Scheduling (No delay before sending the First Feedback / Review Request)',
        params => $params,
        returns => 'string',
        };
}
# @return string
#
sub create_customer_automatic {
    my ($self, %args) = @_;

    # verify the required parameter 'companyid' is set
    unless (exists $args{'companyid'}) {
      croak("Missing the required parameter 'companyid' when calling create_customer_automatic");
    }

    # verify the required parameter 'firstname' is set
    unless (exists $args{'firstname'}) {
      croak("Missing the required parameter 'firstname' when calling create_customer_automatic");
    }

    # verify the required parameter 'lastname' is set
    unless (exists $args{'lastname'}) {
      croak("Missing the required parameter 'lastname' when calling create_customer_automatic");
    }

    # verify the required parameter 'sendtype' is set
    unless (exists $args{'sendtype'}) {
      croak("Missing the required parameter 'sendtype' when calling create_customer_automatic");
    }

    # parse inputs
    my $_resource_path = '/createCustomerAutomatic';

    my $_method = 'POST';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json', 'application/xml');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type('application/x-www-form-urlencoded');

    # form params
    if ( exists $args{'companyid'} ) {
                $form_params->{'companyid'} = $self->{api_client}->to_form_value($args{'companyid'});
    }
    
    # form params
    if ( exists $args{'firstname'} ) {
                $form_params->{'firstname'} = $self->{api_client}->to_form_value($args{'firstname'});
    }
    
    # form params
    if ( exists $args{'lastname'} ) {
                $form_params->{'lastname'} = $self->{api_client}->to_form_value($args{'lastname'});
    }
    
    # form params
    if ( exists $args{'email'} ) {
                $form_params->{'email'} = $self->{api_client}->to_form_value($args{'email'});
    }
    
    # form params
    if ( exists $args{'mobile'} ) {
                $form_params->{'mobile'} = $self->{api_client}->to_form_value($args{'mobile'});
    }
    
    # form params
    if ( exists $args{'address'} ) {
                $form_params->{'address'} = $self->{api_client}->to_form_value($args{'address'});
    }
    
    # form params
    if ( exists $args{'zipcode'} ) {
                $form_params->{'zipcode'} = $self->{api_client}->to_form_value($args{'zipcode'});
    }
    
    # form params
    if ( exists $args{'city'} ) {
                $form_params->{'city'} = $self->{api_client}->to_form_value($args{'city'});
    }
    
    # form params
    if ( exists $args{'state'} ) {
                $form_params->{'state'} = $self->{api_client}->to_form_value($args{'state'});
    }
    
    # form params
    if ( exists $args{'country'} ) {
                $form_params->{'country'} = $self->{api_client}->to_form_value($args{'country'});
    }
    
    # form params
    if ( exists $args{'language'} ) {
                $form_params->{'language'} = $self->{api_client}->to_form_value($args{'language'});
    }
    
    # form params
    if ( exists $args{'sendtype'} ) {
                $form_params->{'sendtype'} = $self->{api_client}->to_form_value($args{'sendtype'});
    }
    
    # form params
    if ( exists $args{'notes'} ) {
                $form_params->{'notes'} = $self->{api_client}->to_form_value($args{'notes'});
    }
    
    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(api_key )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('string', $response);
    return $_response_object;
}

#
# create_customer_automatic_with_delay_review_request
#
# Create a Customer AND a Feedback / Review Request Sequence with Automatic Scheduling (Set a Delay before sending the First Feedback / Review Request)
# 
# @param string $companyid Company ID (required)
# @param string $firstname Customer First Name (required)
# @param string $lastname Customer Last Name (required)
# @param string $sendtype Feedback / Review Requests Sending Method (1 &#x3D; Send via Email, 2 &#x3D; Send via SMS, 1,2 &#x3D; Send via Email AND SMS) Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;1,2\&quot;  (required)
# @param string $delay_before_first_review_request Delay before sending the first Feedback / Review Request (Allowed values: \&quot;immediately\&quot;, \&quot;X minute\&quot;, \&quot;X hour\&quot;, \&quot;X day\&quot;, \&quot;X week\&quot;, \&quot;X month\&quot;, \&quot;X year\&quot;)  (required)
# @param string $email Customer Email (optional)
# @param string $mobile Customer Mobile Phone #: The Mobile Phone # must be formatted in its international version. Eg: +33647523335 (+33 &#x3D; Country Code for France). No leading Zero on Mobile Phone # usually (NOTE: some countries might a leading zero). Here is an excellent script for mobile number formatting: https://github.com/jackocnr/intl-tel-input  (optional)
# @param string $address Customer Postal Address (optional)
# @param string $zipcode Customer Zipcode (optional)
# @param string $city Customer City (optional)
# @param string $state Customer State / Province / Region (optional)
# @param string $country Customer Country: has to be set to the name of the Country in its original language. Eg: Spain &#x3D; EspaÃ±a. Download the sql file of all countries: https://reputationcrm.com/api/repcrm-api-docs/countries.txt  (optional)
# @param string $language Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages  (optional)
# @param string $notes Additional Customer Notes (optional)
{
    my $params = {
    'companyid' => {
        data_type => 'string',
        description => 'Company ID',
        required => '1',
    },
    'firstname' => {
        data_type => 'string',
        description => 'Customer First Name',
        required => '1',
    },
    'lastname' => {
        data_type => 'string',
        description => 'Customer Last Name',
        required => '1',
    },
    'sendtype' => {
        data_type => 'string',
        description => 'Feedback / Review Requests Sending Method (1 &#x3D; Send via Email, 2 &#x3D; Send via SMS, 1,2 &#x3D; Send via Email AND SMS) Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;1,2\&quot; ',
        required => '1',
    },
    'delay_before_first_review_request' => {
        data_type => 'string',
        description => 'Delay before sending the first Feedback / Review Request (Allowed values: \&quot;immediately\&quot;, \&quot;X minute\&quot;, \&quot;X hour\&quot;, \&quot;X day\&quot;, \&quot;X week\&quot;, \&quot;X month\&quot;, \&quot;X year\&quot;) ',
        required => '1',
    },
    'email' => {
        data_type => 'string',
        description => 'Customer Email',
        required => '0',
    },
    'mobile' => {
        data_type => 'string',
        description => 'Customer Mobile Phone #: The Mobile Phone # must be formatted in its international version. Eg: +33647523335 (+33 &#x3D; Country Code for France). No leading Zero on Mobile Phone # usually (NOTE: some countries might a leading zero). Here is an excellent script for mobile number formatting: https://github.com/jackocnr/intl-tel-input ',
        required => '0',
    },
    'address' => {
        data_type => 'string',
        description => 'Customer Postal Address',
        required => '0',
    },
    'zipcode' => {
        data_type => 'string',
        description => 'Customer Zipcode',
        required => '0',
    },
    'city' => {
        data_type => 'string',
        description => 'Customer City',
        required => '0',
    },
    'state' => {
        data_type => 'string',
        description => 'Customer State / Province / Region',
        required => '0',
    },
    'country' => {
        data_type => 'string',
        description => 'Customer Country: has to be set to the name of the Country in its original language. Eg: Spain &#x3D; EspaÃ±a. Download the sql file of all countries: https://reputationcrm.com/api/repcrm-api-docs/countries.txt ',
        required => '0',
    },
    'language' => {
        data_type => 'string',
        description => 'Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages ',
        required => '0',
    },
    'notes' => {
        data_type => 'string',
        description => 'Additional Customer Notes',
        required => '0',
    },
    };
    __PACKAGE__->method_documentation->{ 'create_customer_automatic_with_delay_review_request' } = { 
    	summary => 'Create a Customer AND a Feedback / Review Request Sequence with Automatic Scheduling (Set a Delay before sending the First Feedback / Review Request)',
        params => $params,
        returns => undef,
        };
}
# @return void
#
sub create_customer_automatic_with_delay_review_request {
    my ($self, %args) = @_;

    # verify the required parameter 'companyid' is set
    unless (exists $args{'companyid'}) {
      croak("Missing the required parameter 'companyid' when calling create_customer_automatic_with_delay_review_request");
    }

    # verify the required parameter 'firstname' is set
    unless (exists $args{'firstname'}) {
      croak("Missing the required parameter 'firstname' when calling create_customer_automatic_with_delay_review_request");
    }

    # verify the required parameter 'lastname' is set
    unless (exists $args{'lastname'}) {
      croak("Missing the required parameter 'lastname' when calling create_customer_automatic_with_delay_review_request");
    }

    # verify the required parameter 'sendtype' is set
    unless (exists $args{'sendtype'}) {
      croak("Missing the required parameter 'sendtype' when calling create_customer_automatic_with_delay_review_request");
    }

    # verify the required parameter 'delay_before_first_review_request' is set
    unless (exists $args{'delay_before_first_review_request'}) {
      croak("Missing the required parameter 'delay_before_first_review_request' when calling create_customer_automatic_with_delay_review_request");
    }

    # parse inputs
    my $_resource_path = '/createCustomerAutomaticWithDelayReviewRequest';

    my $_method = 'POST';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json', 'application/xml');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type('application/x-www-form-urlencoded');

    # form params
    if ( exists $args{'companyid'} ) {
                $form_params->{'companyid'} = $self->{api_client}->to_form_value($args{'companyid'});
    }
    
    # form params
    if ( exists $args{'firstname'} ) {
                $form_params->{'firstname'} = $self->{api_client}->to_form_value($args{'firstname'});
    }
    
    # form params
    if ( exists $args{'lastname'} ) {
                $form_params->{'lastname'} = $self->{api_client}->to_form_value($args{'lastname'});
    }
    
    # form params
    if ( exists $args{'email'} ) {
                $form_params->{'email'} = $self->{api_client}->to_form_value($args{'email'});
    }
    
    # form params
    if ( exists $args{'mobile'} ) {
                $form_params->{'mobile'} = $self->{api_client}->to_form_value($args{'mobile'});
    }
    
    # form params
    if ( exists $args{'address'} ) {
                $form_params->{'address'} = $self->{api_client}->to_form_value($args{'address'});
    }
    
    # form params
    if ( exists $args{'zipcode'} ) {
                $form_params->{'zipcode'} = $self->{api_client}->to_form_value($args{'zipcode'});
    }
    
    # form params
    if ( exists $args{'city'} ) {
                $form_params->{'city'} = $self->{api_client}->to_form_value($args{'city'});
    }
    
    # form params
    if ( exists $args{'state'} ) {
                $form_params->{'state'} = $self->{api_client}->to_form_value($args{'state'});
    }
    
    # form params
    if ( exists $args{'country'} ) {
                $form_params->{'country'} = $self->{api_client}->to_form_value($args{'country'});
    }
    
    # form params
    if ( exists $args{'language'} ) {
                $form_params->{'language'} = $self->{api_client}->to_form_value($args{'language'});
    }
    
    # form params
    if ( exists $args{'sendtype'} ) {
                $form_params->{'sendtype'} = $self->{api_client}->to_form_value($args{'sendtype'});
    }
    
    # form params
    if ( exists $args{'notes'} ) {
                $form_params->{'notes'} = $self->{api_client}->to_form_value($args{'notes'});
    }
    
    # form params
    if ( exists $args{'delay_before_first_review_request'} ) {
                $form_params->{'delayBeforeFirstReviewRequest'} = $self->{api_client}->to_form_value($args{'delay_before_first_review_request'});
    }
    
    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(api_key )];

    # make the API Call
    $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    return;
}

#
# create_customer_immediate_first_review_request
#
# Create a Customer AND Feedback / Review Requests
# 
# @param string $companyid Company ID (required)
# @param string $firstname Customer First Name (required)
# @param string $lastname Customer Last Name (required)
# @param string $sendtype Feedback / Review Requests Sending Method (1 &#x3D; Send via Email, 2 &#x3D; Send via SMS, 1,2 &#x3D; Send via Email AND SMS) Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;1,2\&quot;  (required)
# @param string $email Customer Email (optional)
# @param string $mobile Customer Mobile Phone #: The Mobile Phone # must be formatted in its international version. Eg: +33647523335 (+33 &#x3D; Country Code for France). No leading Zero on Mobile Phone # usually (NOTE: some countries might a leading zero). Here is an excellent script for mobile number formatting: https://github.com/jackocnr/intl-tel-input  (optional)
# @param string $address Customer Postal Address (optional)
# @param string $zipcode Customer Zipcode (optional)
# @param string $city Customer City (optional)
# @param string $state Customer State / Province / Region (optional)
# @param string $country Customer Country: has to be set to the name of the Country in its original language. Eg: Spain &#x3D; EspaÃ±a. Download the sql file of all countries: https://reputationcrm.com/api/repcrm-api-docs/countries.txt  (optional)
# @param string $language Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages  (optional)
# @param string $notes Additional Customer Notes (optional)
{
    my $params = {
    'companyid' => {
        data_type => 'string',
        description => 'Company ID',
        required => '1',
    },
    'firstname' => {
        data_type => 'string',
        description => 'Customer First Name',
        required => '1',
    },
    'lastname' => {
        data_type => 'string',
        description => 'Customer Last Name',
        required => '1',
    },
    'sendtype' => {
        data_type => 'string',
        description => 'Feedback / Review Requests Sending Method (1 &#x3D; Send via Email, 2 &#x3D; Send via SMS, 1,2 &#x3D; Send via Email AND SMS) Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;1,2\&quot; ',
        required => '1',
    },
    'email' => {
        data_type => 'string',
        description => 'Customer Email',
        required => '0',
    },
    'mobile' => {
        data_type => 'string',
        description => 'Customer Mobile Phone #: The Mobile Phone # must be formatted in its international version. Eg: +33647523335 (+33 &#x3D; Country Code for France). No leading Zero on Mobile Phone # usually (NOTE: some countries might a leading zero). Here is an excellent script for mobile number formatting: https://github.com/jackocnr/intl-tel-input ',
        required => '0',
    },
    'address' => {
        data_type => 'string',
        description => 'Customer Postal Address',
        required => '0',
    },
    'zipcode' => {
        data_type => 'string',
        description => 'Customer Zipcode',
        required => '0',
    },
    'city' => {
        data_type => 'string',
        description => 'Customer City',
        required => '0',
    },
    'state' => {
        data_type => 'string',
        description => 'Customer State / Province / Region',
        required => '0',
    },
    'country' => {
        data_type => 'string',
        description => 'Customer Country: has to be set to the name of the Country in its original language. Eg: Spain &#x3D; EspaÃ±a. Download the sql file of all countries: https://reputationcrm.com/api/repcrm-api-docs/countries.txt ',
        required => '0',
    },
    'language' => {
        data_type => 'string',
        description => 'Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages ',
        required => '0',
    },
    'notes' => {
        data_type => 'string',
        description => 'Additional Customer Notes',
        required => '0',
    },
    };
    __PACKAGE__->method_documentation->{ 'create_customer_immediate_first_review_request' } = { 
    	summary => 'Create a Customer AND Feedback / Review Requests',
        params => $params,
        returns => undef,
        };
}
# @return void
#
sub create_customer_immediate_first_review_request {
    my ($self, %args) = @_;

    # verify the required parameter 'companyid' is set
    unless (exists $args{'companyid'}) {
      croak("Missing the required parameter 'companyid' when calling create_customer_immediate_first_review_request");
    }

    # verify the required parameter 'firstname' is set
    unless (exists $args{'firstname'}) {
      croak("Missing the required parameter 'firstname' when calling create_customer_immediate_first_review_request");
    }

    # verify the required parameter 'lastname' is set
    unless (exists $args{'lastname'}) {
      croak("Missing the required parameter 'lastname' when calling create_customer_immediate_first_review_request");
    }

    # verify the required parameter 'sendtype' is set
    unless (exists $args{'sendtype'}) {
      croak("Missing the required parameter 'sendtype' when calling create_customer_immediate_first_review_request");
    }

    # parse inputs
    my $_resource_path = '/createCustomerImmediateFirstReviewRequest';

    my $_method = 'POST';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json', 'application/xml');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type('application/x-www-form-urlencoded');

    # form params
    if ( exists $args{'companyid'} ) {
                $form_params->{'companyid'} = $self->{api_client}->to_form_value($args{'companyid'});
    }
    
    # form params
    if ( exists $args{'firstname'} ) {
                $form_params->{'firstname'} = $self->{api_client}->to_form_value($args{'firstname'});
    }
    
    # form params
    if ( exists $args{'lastname'} ) {
                $form_params->{'lastname'} = $self->{api_client}->to_form_value($args{'lastname'});
    }
    
    # form params
    if ( exists $args{'email'} ) {
                $form_params->{'email'} = $self->{api_client}->to_form_value($args{'email'});
    }
    
    # form params
    if ( exists $args{'mobile'} ) {
                $form_params->{'mobile'} = $self->{api_client}->to_form_value($args{'mobile'});
    }
    
    # form params
    if ( exists $args{'address'} ) {
                $form_params->{'address'} = $self->{api_client}->to_form_value($args{'address'});
    }
    
    # form params
    if ( exists $args{'zipcode'} ) {
                $form_params->{'zipcode'} = $self->{api_client}->to_form_value($args{'zipcode'});
    }
    
    # form params
    if ( exists $args{'city'} ) {
                $form_params->{'city'} = $self->{api_client}->to_form_value($args{'city'});
    }
    
    # form params
    if ( exists $args{'state'} ) {
                $form_params->{'state'} = $self->{api_client}->to_form_value($args{'state'});
    }
    
    # form params
    if ( exists $args{'country'} ) {
                $form_params->{'country'} = $self->{api_client}->to_form_value($args{'country'});
    }
    
    # form params
    if ( exists $args{'language'} ) {
                $form_params->{'language'} = $self->{api_client}->to_form_value($args{'language'});
    }
    
    # form params
    if ( exists $args{'sendtype'} ) {
                $form_params->{'sendtype'} = $self->{api_client}->to_form_value($args{'sendtype'});
    }
    
    # form params
    if ( exists $args{'notes'} ) {
                $form_params->{'notes'} = $self->{api_client}->to_form_value($args{'notes'});
    }
    
    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(api_key )];

    # make the API Call
    $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    return;
}

#
# create_customer_manual_schedule_one_review_request
#
# Create a Customer AND a one Feedback / Review Request (Manual Scheduling)
# 
# @param string $companyid Company ID (required)
# @param string $firstname Customer First Name (required)
# @param string $lastname Customer Last Name (required)
# @param string $sendtype Feedback / Review Requests Sending Method (1 &#x3D; Send via Email, 2 &#x3D; Send via SMS, 1,2 &#x3D; Send via Email AND SMS) Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;1,2\&quot;  (required)
# @param string $emailnumber Set which Email Feedback / Requests will be sent (Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;3\&quot;)  (required)
# @param string $smsnumber Set which SMS Feedback / Requests will be sent (Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;3\&quot;)  (required)
# @param string $scheduledate Schedule date (yyyy/mm/dd)  (required)
# @param string $scheduletime Schedule time (HH:MM 24 hours format)  (required)
# @param string $email Customer Email (optional)
# @param string $mobile Customer Mobile Phone #: The Mobile Phone # must be formatted in its international version. Eg: +33647523335 (+33 &#x3D; Country Code for France). No leading Zero on Mobile Phone # usually (NOTE: some countries might a leading zero). Here is an excellent script for mobile number formatting: https://github.com/jackocnr/intl-tel-input  (optional)
# @param string $address Customer Postal Address (optional)
# @param string $zipcode Customer Zipcode (optional)
# @param string $city Customer City (optional)
# @param string $state Customer State / Province / Region (optional)
# @param string $country Customer Country: has to be set to the name of the Country in its original language. Eg: Spain &#x3D; EspaÃ±a. Download the sql file of all countries: https://reputationcrm.com/api/repcrm-api-docs/countries.txt  (optional)
# @param string $language Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages  (optional)
# @param string $notes Additional Customer Notes (optional)
{
    my $params = {
    'companyid' => {
        data_type => 'string',
        description => 'Company ID',
        required => '1',
    },
    'firstname' => {
        data_type => 'string',
        description => 'Customer First Name',
        required => '1',
    },
    'lastname' => {
        data_type => 'string',
        description => 'Customer Last Name',
        required => '1',
    },
    'sendtype' => {
        data_type => 'string',
        description => 'Feedback / Review Requests Sending Method (1 &#x3D; Send via Email, 2 &#x3D; Send via SMS, 1,2 &#x3D; Send via Email AND SMS) Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;1,2\&quot; ',
        required => '1',
    },
    'emailnumber' => {
        data_type => 'string',
        description => 'Set which Email Feedback / Requests will be sent (Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;3\&quot;) ',
        required => '1',
    },
    'smsnumber' => {
        data_type => 'string',
        description => 'Set which SMS Feedback / Requests will be sent (Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;3\&quot;) ',
        required => '1',
    },
    'scheduledate' => {
        data_type => 'string',
        description => 'Schedule date (yyyy/mm/dd) ',
        required => '1',
    },
    'scheduletime' => {
        data_type => 'string',
        description => 'Schedule time (HH:MM 24 hours format) ',
        required => '1',
    },
    'email' => {
        data_type => 'string',
        description => 'Customer Email',
        required => '0',
    },
    'mobile' => {
        data_type => 'string',
        description => 'Customer Mobile Phone #: The Mobile Phone # must be formatted in its international version. Eg: +33647523335 (+33 &#x3D; Country Code for France). No leading Zero on Mobile Phone # usually (NOTE: some countries might a leading zero). Here is an excellent script for mobile number formatting: https://github.com/jackocnr/intl-tel-input ',
        required => '0',
    },
    'address' => {
        data_type => 'string',
        description => 'Customer Postal Address',
        required => '0',
    },
    'zipcode' => {
        data_type => 'string',
        description => 'Customer Zipcode',
        required => '0',
    },
    'city' => {
        data_type => 'string',
        description => 'Customer City',
        required => '0',
    },
    'state' => {
        data_type => 'string',
        description => 'Customer State / Province / Region',
        required => '0',
    },
    'country' => {
        data_type => 'string',
        description => 'Customer Country: has to be set to the name of the Country in its original language. Eg: Spain &#x3D; EspaÃ±a. Download the sql file of all countries: https://reputationcrm.com/api/repcrm-api-docs/countries.txt ',
        required => '0',
    },
    'language' => {
        data_type => 'string',
        description => 'Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages ',
        required => '0',
    },
    'notes' => {
        data_type => 'string',
        description => 'Additional Customer Notes',
        required => '0',
    },
    };
    __PACKAGE__->method_documentation->{ 'create_customer_manual_schedule_one_review_request' } = { 
    	summary => 'Create a Customer AND a one Feedback / Review Request (Manual Scheduling)',
        params => $params,
        returns => undef,
        };
}
# @return void
#
sub create_customer_manual_schedule_one_review_request {
    my ($self, %args) = @_;

    # verify the required parameter 'companyid' is set
    unless (exists $args{'companyid'}) {
      croak("Missing the required parameter 'companyid' when calling create_customer_manual_schedule_one_review_request");
    }

    # verify the required parameter 'firstname' is set
    unless (exists $args{'firstname'}) {
      croak("Missing the required parameter 'firstname' when calling create_customer_manual_schedule_one_review_request");
    }

    # verify the required parameter 'lastname' is set
    unless (exists $args{'lastname'}) {
      croak("Missing the required parameter 'lastname' when calling create_customer_manual_schedule_one_review_request");
    }

    # verify the required parameter 'sendtype' is set
    unless (exists $args{'sendtype'}) {
      croak("Missing the required parameter 'sendtype' when calling create_customer_manual_schedule_one_review_request");
    }

    # verify the required parameter 'emailnumber' is set
    unless (exists $args{'emailnumber'}) {
      croak("Missing the required parameter 'emailnumber' when calling create_customer_manual_schedule_one_review_request");
    }

    # verify the required parameter 'smsnumber' is set
    unless (exists $args{'smsnumber'}) {
      croak("Missing the required parameter 'smsnumber' when calling create_customer_manual_schedule_one_review_request");
    }

    # verify the required parameter 'scheduledate' is set
    unless (exists $args{'scheduledate'}) {
      croak("Missing the required parameter 'scheduledate' when calling create_customer_manual_schedule_one_review_request");
    }

    # verify the required parameter 'scheduletime' is set
    unless (exists $args{'scheduletime'}) {
      croak("Missing the required parameter 'scheduletime' when calling create_customer_manual_schedule_one_review_request");
    }

    # parse inputs
    my $_resource_path = '/createCustomerManualScheduleOneReviewRequest';

    my $_method = 'POST';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json', 'application/xml');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type('application/x-www-form-urlencoded');

    # form params
    if ( exists $args{'companyid'} ) {
                $form_params->{'companyid'} = $self->{api_client}->to_form_value($args{'companyid'});
    }
    
    # form params
    if ( exists $args{'firstname'} ) {
                $form_params->{'firstname'} = $self->{api_client}->to_form_value($args{'firstname'});
    }
    
    # form params
    if ( exists $args{'lastname'} ) {
                $form_params->{'lastname'} = $self->{api_client}->to_form_value($args{'lastname'});
    }
    
    # form params
    if ( exists $args{'email'} ) {
                $form_params->{'email'} = $self->{api_client}->to_form_value($args{'email'});
    }
    
    # form params
    if ( exists $args{'mobile'} ) {
                $form_params->{'mobile'} = $self->{api_client}->to_form_value($args{'mobile'});
    }
    
    # form params
    if ( exists $args{'address'} ) {
                $form_params->{'address'} = $self->{api_client}->to_form_value($args{'address'});
    }
    
    # form params
    if ( exists $args{'zipcode'} ) {
                $form_params->{'zipcode'} = $self->{api_client}->to_form_value($args{'zipcode'});
    }
    
    # form params
    if ( exists $args{'city'} ) {
                $form_params->{'city'} = $self->{api_client}->to_form_value($args{'city'});
    }
    
    # form params
    if ( exists $args{'state'} ) {
                $form_params->{'state'} = $self->{api_client}->to_form_value($args{'state'});
    }
    
    # form params
    if ( exists $args{'country'} ) {
                $form_params->{'country'} = $self->{api_client}->to_form_value($args{'country'});
    }
    
    # form params
    if ( exists $args{'language'} ) {
                $form_params->{'language'} = $self->{api_client}->to_form_value($args{'language'});
    }
    
    # form params
    if ( exists $args{'sendtype'} ) {
                $form_params->{'sendtype'} = $self->{api_client}->to_form_value($args{'sendtype'});
    }
    
    # form params
    if ( exists $args{'notes'} ) {
                $form_params->{'notes'} = $self->{api_client}->to_form_value($args{'notes'});
    }
    
    # form params
    if ( exists $args{'emailnumber'} ) {
                $form_params->{'emailnumber'} = $self->{api_client}->to_form_value($args{'emailnumber'});
    }
    
    # form params
    if ( exists $args{'smsnumber'} ) {
                $form_params->{'smsnumber'} = $self->{api_client}->to_form_value($args{'smsnumber'});
    }
    
    # form params
    if ( exists $args{'scheduledate'} ) {
                $form_params->{'scheduledate'} = $self->{api_client}->to_form_value($args{'scheduledate'});
    }
    
    # form params
    if ( exists $args{'scheduletime'} ) {
                $form_params->{'scheduletime'} = $self->{api_client}->to_form_value($args{'scheduletime'});
    }
    
    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(api_key )];

    # make the API Call
    $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    return;
}

#
# delete_customer
#
# Delete ONE Customer record
# 
# @param string $customerid Customer ID (required)
{
    my $params = {
    'customerid' => {
        data_type => 'string',
        description => 'Customer ID',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'delete_customer' } = { 
    	summary => 'Delete ONE Customer record',
        params => $params,
        returns => undef,
        };
}
# @return void
#
sub delete_customer {
    my ($self, %args) = @_;

    # verify the required parameter 'customerid' is set
    unless (exists $args{'customerid'}) {
      croak("Missing the required parameter 'customerid' when calling delete_customer");
    }

    # parse inputs
    my $_resource_path = '/deleteCustomer';

    my $_method = 'DELETE';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json', 'application/xml');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type('application/x-www-form-urlencoded');

    # form params
    if ( exists $args{'customerid'} ) {
                $form_params->{'customerid'} = $self->{api_client}->to_form_value($args{'customerid'});
    }
    
    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(api_key )];

    # make the API Call
    $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    return;
}

#
# get_all_customers_bycompany_id
#
# Get Information on ALL Customers of a Company / Location / Feedback Page
# 
# @param string $companyid Company ID (required)
{
    my $params = {
    'companyid' => {
        data_type => 'string',
        description => 'Company ID',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'get_all_customers_bycompany_id' } = { 
    	summary => 'Get Information on ALL Customers of a Company / Location / Feedback Page',
        params => $params,
        returns => 'ARRAY[Customer]',
        };
}
# @return ARRAY[Customer]
#
sub get_all_customers_bycompany_id {
    my ($self, %args) = @_;

    # verify the required parameter 'companyid' is set
    unless (exists $args{'companyid'}) {
      croak("Missing the required parameter 'companyid' when calling get_all_customers_bycompany_id");
    }

    # parse inputs
    my $_resource_path = '/getAllCustomersBycompanyId';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json', 'application/xml');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type('application/x-www-form-urlencoded');

    # query params
    if ( exists $args{'companyid'}) {
        $query_params->{'companyid'} = $self->{api_client}->to_query_value($args{'companyid'});
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(api_key )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ARRAY[Customer]', $response);
    return $_response_object;
}

#
# get_customers_who_have_not_yet_submitted_review
#
# Get a list of Customers who have not yet submitted their Review / Feedback
# 
# @param string $companyid Company ID (required)
{
    my $params = {
    'companyid' => {
        data_type => 'string',
        description => 'Company ID',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'get_customers_who_have_not_yet_submitted_review' } = { 
    	summary => 'Get a list of Customers who have not yet submitted their Review / Feedback',
        params => $params,
        returns => 'ARRAY[CustomerWhoHaveNotResponded]',
        };
}
# @return ARRAY[CustomerWhoHaveNotResponded]
#
sub get_customers_who_have_not_yet_submitted_review {
    my ($self, %args) = @_;

    # verify the required parameter 'companyid' is set
    unless (exists $args{'companyid'}) {
      croak("Missing the required parameter 'companyid' when calling get_customers_who_have_not_yet_submitted_review");
    }

    # parse inputs
    my $_resource_path = '/getCustomersWhoHaveNotYetSubmittedReview';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json', 'application/xml');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type('application/x-www-form-urlencoded');

    # query params
    if ( exists $args{'companyid'}) {
        $query_params->{'companyid'} = $self->{api_client}->to_query_value($args{'companyid'});
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(api_key )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ARRAY[CustomerWhoHaveNotResponded]', $response);
    return $_response_object;
}

#
# get_single_customer
#
# Get Information of ONE Customer
# 
# @param string $customerid Customer ID (required)
{
    my $params = {
    'customerid' => {
        data_type => 'string',
        description => 'Customer ID',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'get_single_customer' } = { 
    	summary => 'Get Information of ONE Customer',
        params => $params,
        returns => 'ARRAY[Customer]',
        };
}
# @return ARRAY[Customer]
#
sub get_single_customer {
    my ($self, %args) = @_;

    # verify the required parameter 'customerid' is set
    unless (exists $args{'customerid'}) {
      croak("Missing the required parameter 'customerid' when calling get_single_customer");
    }

    # parse inputs
    my $_resource_path = '/getSingleCustomer';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json', 'application/xml');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type('application/x-www-form-urlencoded');

    # query params
    if ( exists $args{'customerid'}) {
        $query_params->{'customerid'} = $self->{api_client}->to_query_value($args{'customerid'});
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(api_key )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ARRAY[Customer]', $response);
    return $_response_object;
}

#
# update_customer
#
# Update the record of ONE Customer
# 
# @param string $customerid Customer ID (required)
# @param string $firstname Customer First Name (required)
# @param string $lastname Customer Last Name (required)
# @param string $notes Additional Customer Notes (required)
# @param string $email Customer Email (optional)
# @param string $mobile Customer Mobile Phone (optional)
# @param string $address Customer Postal Address (optional)
# @param string $zipcode Customer Zipcode (optional)
# @param string $city Customer City (optional)
# @param string $state Customer State / Province / Region (optional)
# @param string $country Customer Country (optional)
# @param string $language Customer Language (optional)
{
    my $params = {
    'customerid' => {
        data_type => 'string',
        description => 'Customer ID',
        required => '1',
    },
    'firstname' => {
        data_type => 'string',
        description => 'Customer First Name',
        required => '1',
    },
    'lastname' => {
        data_type => 'string',
        description => 'Customer Last Name',
        required => '1',
    },
    'notes' => {
        data_type => 'string',
        description => 'Additional Customer Notes',
        required => '1',
    },
    'email' => {
        data_type => 'string',
        description => 'Customer Email',
        required => '0',
    },
    'mobile' => {
        data_type => 'string',
        description => 'Customer Mobile Phone',
        required => '0',
    },
    'address' => {
        data_type => 'string',
        description => 'Customer Postal Address',
        required => '0',
    },
    'zipcode' => {
        data_type => 'string',
        description => 'Customer Zipcode',
        required => '0',
    },
    'city' => {
        data_type => 'string',
        description => 'Customer City',
        required => '0',
    },
    'state' => {
        data_type => 'string',
        description => 'Customer State / Province / Region',
        required => '0',
    },
    'country' => {
        data_type => 'string',
        description => 'Customer Country',
        required => '0',
    },
    'language' => {
        data_type => 'string',
        description => 'Customer Language',
        required => '0',
    },
    };
    __PACKAGE__->method_documentation->{ 'update_customer' } = { 
    	summary => 'Update the record of ONE Customer',
        params => $params,
        returns => undef,
        };
}
# @return void
#
sub update_customer {
    my ($self, %args) = @_;

    # verify the required parameter 'customerid' is set
    unless (exists $args{'customerid'}) {
      croak("Missing the required parameter 'customerid' when calling update_customer");
    }

    # verify the required parameter 'firstname' is set
    unless (exists $args{'firstname'}) {
      croak("Missing the required parameter 'firstname' when calling update_customer");
    }

    # verify the required parameter 'lastname' is set
    unless (exists $args{'lastname'}) {
      croak("Missing the required parameter 'lastname' when calling update_customer");
    }

    # verify the required parameter 'notes' is set
    unless (exists $args{'notes'}) {
      croak("Missing the required parameter 'notes' when calling update_customer");
    }

    # parse inputs
    my $_resource_path = '/updateCustomer';

    my $_method = 'PUT';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json', 'application/xml');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type('application/x-www-form-urlencoded');

    # form params
    if ( exists $args{'customerid'} ) {
                $form_params->{'customerid'} = $self->{api_client}->to_form_value($args{'customerid'});
    }
    
    # form params
    if ( exists $args{'firstname'} ) {
                $form_params->{'firstname'} = $self->{api_client}->to_form_value($args{'firstname'});
    }
    
    # form params
    if ( exists $args{'lastname'} ) {
                $form_params->{'lastname'} = $self->{api_client}->to_form_value($args{'lastname'});
    }
    
    # form params
    if ( exists $args{'email'} ) {
                $form_params->{'email'} = $self->{api_client}->to_form_value($args{'email'});
    }
    
    # form params
    if ( exists $args{'mobile'} ) {
                $form_params->{'mobile'} = $self->{api_client}->to_form_value($args{'mobile'});
    }
    
    # form params
    if ( exists $args{'address'} ) {
                $form_params->{'address'} = $self->{api_client}->to_form_value($args{'address'});
    }
    
    # form params
    if ( exists $args{'zipcode'} ) {
                $form_params->{'zipcode'} = $self->{api_client}->to_form_value($args{'zipcode'});
    }
    
    # form params
    if ( exists $args{'city'} ) {
                $form_params->{'city'} = $self->{api_client}->to_form_value($args{'city'});
    }
    
    # form params
    if ( exists $args{'state'} ) {
                $form_params->{'state'} = $self->{api_client}->to_form_value($args{'state'});
    }
    
    # form params
    if ( exists $args{'country'} ) {
                $form_params->{'country'} = $self->{api_client}->to_form_value($args{'country'});
    }
    
    # form params
    if ( exists $args{'language'} ) {
                $form_params->{'language'} = $self->{api_client}->to_form_value($args{'language'});
    }
    
    # form params
    if ( exists $args{'notes'} ) {
                $form_params->{'notes'} = $self->{api_client}->to_form_value($args{'notes'});
    }
    
    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(api_key )];

    # make the API Call
    $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    return;
}

1;
