=begin comment

Reputation CRM API

Move your app forward with the Reputation CRM API  To get your `API key`, visit [Reputation CRM](https://reputationcrm.com/settings/index/Reputation-Builder)  Your API Key can be found in Settings -> Reputation Builder -> Reputation Builder -> API Tab   [Download API SDK](https://reputationcrm.com/developers/documentation/v2/downloads)  [API Explorer](https://reputationcrm.com/developers/documentation/v2/explorer/) 

OpenAPI spec version: 2.0.2
Contact: support@reputationcrm.com
Generated by: https://github.com/swagger-api/swagger-codegen.git

=end comment

=cut

#
# NOTE: This class is auto generated by the swagger code generator program. 
# Do not edit the class manually.
# Ref: https://github.com/swagger-api/swagger-codegen
#
package WWW::SwaggerClient::QueueApi;

require 5.6.0;
use strict;
use warnings;
use utf8; 
use Exporter;
use Carp qw( croak );
use Log::Any qw($log);

use WWW::SwaggerClient::ApiClient;

use base "Class::Data::Inheritable";

__PACKAGE__->mk_classdata('method_documentation' => {});

sub new {
    my $class = shift;
    my $api_client;

    if ($_[0] && ref $_[0] && ref $_[0] eq 'WWW::SwaggerClient::ApiClient' ) {
        $api_client = $_[0];
    } else {
        $api_client = WWW::SwaggerClient::ApiClient->new(@_);
    }

    bless { api_client => $api_client }, $class;

}


#
# delete_queue_by_customer_id
#
# Delete requests of a customer
# 
# @param string $customerid Customer ID (required)
{
    my $params = {
    'customerid' => {
        data_type => 'string',
        description => 'Customer ID',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'delete_queue_by_customer_id' } = { 
    	summary => 'Delete requests of a customer',
        params => $params,
        returns => undef,
        };
}
# @return void
#
sub delete_queue_by_customer_id {
    my ($self, %args) = @_;

    # verify the required parameter 'customerid' is set
    unless (exists $args{'customerid'}) {
      croak("Missing the required parameter 'customerid' when calling delete_queue_by_customer_id");
    }

    # parse inputs
    my $_resource_path = '/deleteQueueByCustomerId';

    my $_method = 'DELETE';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json', 'application/xml');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type('application/x-www-form-urlencoded');

    # form params
    if ( exists $args{'customerid'} ) {
                $form_params->{'customerid'} = $self->{api_client}->to_form_value($args{'customerid'});
    }
    
    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(api_key )];

    # make the API Call
    $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    return;
}

#
# delete_queue_bycompany_id
#
# Delete requests of a company
# 
# @param string $companyid Company ID (required)
{
    my $params = {
    'companyid' => {
        data_type => 'string',
        description => 'Company ID',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'delete_queue_bycompany_id' } = { 
    	summary => 'Delete requests of a company',
        params => $params,
        returns => undef,
        };
}
# @return void
#
sub delete_queue_bycompany_id {
    my ($self, %args) = @_;

    # verify the required parameter 'companyid' is set
    unless (exists $args{'companyid'}) {
      croak("Missing the required parameter 'companyid' when calling delete_queue_bycompany_id");
    }

    # parse inputs
    my $_resource_path = '/deleteQueueBycompanyId';

    my $_method = 'DELETE';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json', 'application/xml');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type('application/x-www-form-urlencoded');

    # form params
    if ( exists $args{'companyid'} ) {
                $form_params->{'companyid'} = $self->{api_client}->to_form_value($args{'companyid'});
    }
    
    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(api_key )];

    # make the API Call
    $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    return;
}

#
# get_queue_bycompany_id
#
# Get a customerâ€™s queue
# 
# @param string $companyid Company ID (required)
{
    my $params = {
    'companyid' => {
        data_type => 'string',
        description => 'Company ID',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'get_queue_bycompany_id' } = { 
    	summary => 'Get a customerâ€™s queue',
        params => $params,
        returns => 'ARRAY[Queue]',
        };
}
# @return ARRAY[Queue]
#
sub get_queue_bycompany_id {
    my ($self, %args) = @_;

    # verify the required parameter 'companyid' is set
    unless (exists $args{'companyid'}) {
      croak("Missing the required parameter 'companyid' when calling get_queue_bycompany_id");
    }

    # parse inputs
    my $_resource_path = '/getQueueBycompanyId';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json', 'application/xml');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type('application/x-www-form-urlencoded');

    # query params
    if ( exists $args{'companyid'}) {
        $query_params->{'companyid'} = $self->{api_client}->to_query_value($args{'companyid'});
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(api_key )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ARRAY[Queue]', $response);
    return $_response_object;
}

#
# get_single_customer_queue
#
# Get a customerâ€™s queue
# 
# @param string $customerid Customer ID (required)
{
    my $params = {
    'customerid' => {
        data_type => 'string',
        description => 'Customer ID',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'get_single_customer_queue' } = { 
    	summary => 'Get a customerâ€™s queue',
        params => $params,
        returns => 'ARRAY[Queue]',
        };
}
# @return ARRAY[Queue]
#
sub get_single_customer_queue {
    my ($self, %args) = @_;

    # verify the required parameter 'customerid' is set
    unless (exists $args{'customerid'}) {
      croak("Missing the required parameter 'customerid' when calling get_single_customer_queue");
    }

    # parse inputs
    my $_resource_path = '/getQueueByCustomerId';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json', 'application/xml');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type('application/x-www-form-urlencoded');

    # query params
    if ( exists $args{'customerid'}) {
        $query_params->{'customerid'} = $self->{api_client}->to_query_value($args{'customerid'});
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(api_key )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ARRAY[Queue]', $response);
    return $_response_object;
}

1;
