=begin comment

Reputation CRM API

Move your app forward with the Reputation CRM API  To get your `API key`, visit [Reputation CRM](https://reputationcrm.com/settings/index/Reputation-Builder)  Your API Key can be found in Settings -> Reputation Builder -> Reputation Builder -> API Tab   [Download API SDK](https://reputationcrm.com/developers/documentation/v2/downloads)  [API Explorer](https://reputationcrm.com/developers/documentation/v2/explorer/) 

OpenAPI spec version: 2.0.2
Contact: support@reputationcrm.com
Generated by: https://github.com/swagger-api/swagger-codegen.git

=end comment

=cut

#
# NOTE: This class is auto generated by the swagger code generator program. 
# Do not edit the class manually.
# Ref: https://github.com/swagger-api/swagger-codegen
#
package WWW::SwaggerClient::RescheduleApi;

require 5.6.0;
use strict;
use warnings;
use utf8; 
use Exporter;
use Carp qw( croak );
use Log::Any qw($log);

use WWW::SwaggerClient::ApiClient;

use base "Class::Data::Inheritable";

__PACKAGE__->mk_classdata('method_documentation' => {});

sub new {
    my $class = shift;
    my $api_client;

    if ($_[0] && ref $_[0] && ref $_[0] eq 'WWW::SwaggerClient::ApiClient' ) {
        $api_client = $_[0];
    } else {
        $api_client = WWW::SwaggerClient::ApiClient->new(@_);
    }

    bless { api_client => $api_client }, $class;

}


#
# reschedule_customer_automatic
#
# Reschedule Customer (Automatic)
# 
# @param string $customerid Customer ID (required)
# @param string $language Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages  (required)
{
    my $params = {
    'customerid' => {
        data_type => 'string',
        description => 'Customer ID',
        required => '1',
    },
    'language' => {
        data_type => 'string',
        description => 'Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages ',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'reschedule_customer_automatic' } = { 
    	summary => 'Reschedule Customer (Automatic)',
        params => $params,
        returns => undef,
        };
}
# @return void
#
sub reschedule_customer_automatic {
    my ($self, %args) = @_;

    # verify the required parameter 'customerid' is set
    unless (exists $args{'customerid'}) {
      croak("Missing the required parameter 'customerid' when calling reschedule_customer_automatic");
    }

    # verify the required parameter 'language' is set
    unless (exists $args{'language'}) {
      croak("Missing the required parameter 'language' when calling reschedule_customer_automatic");
    }

    # parse inputs
    my $_resource_path = '/rescheduleCustomerAutomatic';

    my $_method = 'POST';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json', 'application/xml');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type('application/x-www-form-urlencoded');

    # form params
    if ( exists $args{'customerid'} ) {
                $form_params->{'customerid'} = $self->{api_client}->to_form_value($args{'customerid'});
    }
    
    # form params
    if ( exists $args{'language'} ) {
                $form_params->{'language'} = $self->{api_client}->to_form_value($args{'language'});
    }
    
    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(api_key )];

    # make the API Call
    $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    return;
}

#
# reschedule_customer_immediate
#
# Reschedule Customer (Send right away)
# 
# @param string $customerid Customer ID (required)
# @param string $language Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages  (required)
{
    my $params = {
    'customerid' => {
        data_type => 'string',
        description => 'Customer ID',
        required => '1',
    },
    'language' => {
        data_type => 'string',
        description => 'Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages ',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'reschedule_customer_immediate' } = { 
    	summary => 'Reschedule Customer (Send right away)',
        params => $params,
        returns => undef,
        };
}
# @return void
#
sub reschedule_customer_immediate {
    my ($self, %args) = @_;

    # verify the required parameter 'customerid' is set
    unless (exists $args{'customerid'}) {
      croak("Missing the required parameter 'customerid' when calling reschedule_customer_immediate");
    }

    # verify the required parameter 'language' is set
    unless (exists $args{'language'}) {
      croak("Missing the required parameter 'language' when calling reschedule_customer_immediate");
    }

    # parse inputs
    my $_resource_path = '/rescheduleCustomerImmediate';

    my $_method = 'POST';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json', 'application/xml');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type('application/x-www-form-urlencoded');

    # form params
    if ( exists $args{'customerid'} ) {
                $form_params->{'customerid'} = $self->{api_client}->to_form_value($args{'customerid'});
    }
    
    # form params
    if ( exists $args{'language'} ) {
                $form_params->{'language'} = $self->{api_client}->to_form_value($args{'language'});
    }
    
    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(api_key )];

    # make the API Call
    $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    return;
}

#
# reschedule_manual_one_review_request
#
# Reschedule Customer (Manual Schedule)
# 
# @param string $customerid Customer ID (required)
# @param string $language Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages  (required)
# @param string $scheduledate Schedule date (yyyy/mm/dd)  (required)
# @param string $scheduletime Schedule time (HH:MM 24 hours format)  (required)
# @param string $emailnumber Set which Email Feedback / Requests will be sent (Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;3\&quot;)  (required)
# @param string $smsnumber Set which SMS Feedback / Requests will be sent (Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;3\&quot;)  (required)
{
    my $params = {
    'customerid' => {
        data_type => 'string',
        description => 'Customer ID',
        required => '1',
    },
    'language' => {
        data_type => 'string',
        description => 'Customer Language (Language 2 letter ISO code: en, fr, es, it...). For a complete list of supported languages, please check: https://reputationaegis.com/en/features/supported-languages ',
        required => '1',
    },
    'scheduledate' => {
        data_type => 'string',
        description => 'Schedule date (yyyy/mm/dd) ',
        required => '1',
    },
    'scheduletime' => {
        data_type => 'string',
        description => 'Schedule time (HH:MM 24 hours format) ',
        required => '1',
    },
    'emailnumber' => {
        data_type => 'string',
        description => 'Set which Email Feedback / Requests will be sent (Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;3\&quot;) ',
        required => '1',
    },
    'smsnumber' => {
        data_type => 'string',
        description => 'Set which SMS Feedback / Requests will be sent (Allowed values: \&quot;1\&quot;, \&quot;2\&quot;, \&quot;3\&quot;) ',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'reschedule_manual_one_review_request' } = { 
    	summary => 'Reschedule Customer (Manual Schedule)',
        params => $params,
        returns => undef,
        };
}
# @return void
#
sub reschedule_manual_one_review_request {
    my ($self, %args) = @_;

    # verify the required parameter 'customerid' is set
    unless (exists $args{'customerid'}) {
      croak("Missing the required parameter 'customerid' when calling reschedule_manual_one_review_request");
    }

    # verify the required parameter 'language' is set
    unless (exists $args{'language'}) {
      croak("Missing the required parameter 'language' when calling reschedule_manual_one_review_request");
    }

    # verify the required parameter 'scheduledate' is set
    unless (exists $args{'scheduledate'}) {
      croak("Missing the required parameter 'scheduledate' when calling reschedule_manual_one_review_request");
    }

    # verify the required parameter 'scheduletime' is set
    unless (exists $args{'scheduletime'}) {
      croak("Missing the required parameter 'scheduletime' when calling reschedule_manual_one_review_request");
    }

    # verify the required parameter 'emailnumber' is set
    unless (exists $args{'emailnumber'}) {
      croak("Missing the required parameter 'emailnumber' when calling reschedule_manual_one_review_request");
    }

    # verify the required parameter 'smsnumber' is set
    unless (exists $args{'smsnumber'}) {
      croak("Missing the required parameter 'smsnumber' when calling reschedule_manual_one_review_request");
    }

    # parse inputs
    my $_resource_path = '/rescheduleManualOneReviewRequest';

    my $_method = 'POST';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json', 'application/xml');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type('application/x-www-form-urlencoded');

    # form params
    if ( exists $args{'customerid'} ) {
                $form_params->{'customerid'} = $self->{api_client}->to_form_value($args{'customerid'});
    }
    
    # form params
    if ( exists $args{'language'} ) {
                $form_params->{'language'} = $self->{api_client}->to_form_value($args{'language'});
    }
    
    # form params
    if ( exists $args{'scheduledate'} ) {
                $form_params->{'scheduledate'} = $self->{api_client}->to_form_value($args{'scheduledate'});
    }
    
    # form params
    if ( exists $args{'scheduletime'} ) {
                $form_params->{'scheduletime'} = $self->{api_client}->to_form_value($args{'scheduletime'});
    }
    
    # form params
    if ( exists $args{'emailnumber'} ) {
                $form_params->{'emailnumber'} = $self->{api_client}->to_form_value($args{'emailnumber'});
    }
    
    # form params
    if ( exists $args{'smsnumber'} ) {
                $form_params->{'smsnumber'} = $self->{api_client}->to_form_value($args{'smsnumber'});
    }
    
    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(api_key )];

    # make the API Call
    $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    return;
}

1;
