=begin comment

Reputation CRM API

Move your app forward with the Reputation CRM API  To get your `API key`, visit [Reputation CRM](https://reputationcrm.com/settings/index/Reputation-Builder)  Your API Key can be found in Settings -> Reputation Builder -> Reputation Builder -> API Tab   [Download API SDK](https://reputationcrm.com/developers/documentation/v2/downloads)  [API Explorer](https://reputationcrm.com/developers/documentation/v2/explorer/) 

OpenAPI spec version: 2.0.2
Contact: support@reputationcrm.com
Generated by: https://github.com/swagger-api/swagger-codegen.git

=end comment

=cut

#
# NOTE: This class is auto generated by the swagger code generator program. 
# Do not edit the class manually.
# Ref: https://github.com/swagger-api/swagger-codegen
#
package WWW::SwaggerClient::ReviewsApi;

require 5.6.0;
use strict;
use warnings;
use utf8; 
use Exporter;
use Carp qw( croak );
use Log::Any qw($log);

use WWW::SwaggerClient::ApiClient;

use base "Class::Data::Inheritable";

__PACKAGE__->mk_classdata('method_documentation' => {});

sub new {
    my $class = shift;
    my $api_client;

    if ($_[0] && ref $_[0] && ref $_[0] eq 'WWW::SwaggerClient::ApiClient' ) {
        $api_client = $_[0];
    } else {
        $api_client = WWW::SwaggerClient::ApiClient->new(@_);
    }

    bless { api_client => $api_client }, $class;

}


#
# get_commentson_review
#
# Get review comments
# 
# @param string $companyid Company ID (optional)
# @param string $reviewid Review ID (optional)
{
    my $params = {
    'companyid' => {
        data_type => 'string',
        description => 'Company ID',
        required => '0',
    },
    'reviewid' => {
        data_type => 'string',
        description => 'Review ID',
        required => '0',
    },
    };
    __PACKAGE__->method_documentation->{ 'get_commentson_review' } = { 
    	summary => 'Get review comments',
        params => $params,
        returns => 'ARRAY[Comment]',
        };
}
# @return ARRAY[Comment]
#
sub get_commentson_review {
    my ($self, %args) = @_;

    # parse inputs
    my $_resource_path = '/getCommentsonReview';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json', 'application/xml');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type('application/x-www-form-urlencoded');

    # query params
    if ( exists $args{'companyid'}) {
        $query_params->{'companyid'} = $self->{api_client}->to_query_value($args{'companyid'});
    }

    # query params
    if ( exists $args{'reviewid'}) {
        $query_params->{'reviewid'} = $self->{api_client}->to_query_value($args{'reviewid'});
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(api_key )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ARRAY[Comment]', $response);
    return $_response_object;
}

#
# get_reviews_by_company_id
#
# Get X last reviews less than X days old of a company
# 
# @param string $companyid Company ID (required)
# @param string $how_many_reviews How many reviews (required)
# @param string $last_how_many_days How many days back (required)
{
    my $params = {
    'companyid' => {
        data_type => 'string',
        description => 'Company ID',
        required => '1',
    },
    'how_many_reviews' => {
        data_type => 'string',
        description => 'How many reviews',
        required => '1',
    },
    'last_how_many_days' => {
        data_type => 'string',
        description => 'How many days back',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'get_reviews_by_company_id' } = { 
    	summary => 'Get X last reviews less than X days old of a company',
        params => $params,
        returns => 'ARRAY[Review]',
        };
}
# @return ARRAY[Review]
#
sub get_reviews_by_company_id {
    my ($self, %args) = @_;

    # verify the required parameter 'companyid' is set
    unless (exists $args{'companyid'}) {
      croak("Missing the required parameter 'companyid' when calling get_reviews_by_company_id");
    }

    # verify the required parameter 'how_many_reviews' is set
    unless (exists $args{'how_many_reviews'}) {
      croak("Missing the required parameter 'how_many_reviews' when calling get_reviews_by_company_id");
    }

    # verify the required parameter 'last_how_many_days' is set
    unless (exists $args{'last_how_many_days'}) {
      croak("Missing the required parameter 'last_how_many_days' when calling get_reviews_by_company_id");
    }

    # parse inputs
    my $_resource_path = '/getReviewsByCompanyID';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json', 'application/xml');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type('application/x-www-form-urlencoded');

    # query params
    if ( exists $args{'companyid'}) {
        $query_params->{'companyid'} = $self->{api_client}->to_query_value($args{'companyid'});
    }

    # query params
    if ( exists $args{'how_many_reviews'}) {
        $query_params->{'howManyReviews'} = $self->{api_client}->to_query_value($args{'how_many_reviews'});
    }

    # query params
    if ( exists $args{'last_how_many_days'}) {
        $query_params->{'lastHowManyDays'} = $self->{api_client}->to_query_value($args{'last_how_many_days'});
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(api_key )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ARRAY[Review]', $response);
    return $_response_object;
}

#
# get_reviews_by_company_id_and_rating
#
# Get X last reviews that equal or over X stars of a company
# 
# @param string $companyid Company ID (required)
# @param string $how_many_reviews How many reviews (required)
# @param string $last_how_many_days How many days back (required)
# @param string $minimum_ratings Minimum review rating (reviews that are equal or over minimumRatings stars) (required)
# @param string $maximum_ratings Maximum review rating (required)
{
    my $params = {
    'companyid' => {
        data_type => 'string',
        description => 'Company ID',
        required => '1',
    },
    'how_many_reviews' => {
        data_type => 'string',
        description => 'How many reviews',
        required => '1',
    },
    'last_how_many_days' => {
        data_type => 'string',
        description => 'How many days back',
        required => '1',
    },
    'minimum_ratings' => {
        data_type => 'string',
        description => 'Minimum review rating (reviews that are equal or over minimumRatings stars)',
        required => '1',
    },
    'maximum_ratings' => {
        data_type => 'string',
        description => 'Maximum review rating',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'get_reviews_by_company_id_and_rating' } = { 
    	summary => 'Get X last reviews that equal or over X stars of a company',
        params => $params,
        returns => 'ARRAY[Review]',
        };
}
# @return ARRAY[Review]
#
sub get_reviews_by_company_id_and_rating {
    my ($self, %args) = @_;

    # verify the required parameter 'companyid' is set
    unless (exists $args{'companyid'}) {
      croak("Missing the required parameter 'companyid' when calling get_reviews_by_company_id_and_rating");
    }

    # verify the required parameter 'how_many_reviews' is set
    unless (exists $args{'how_many_reviews'}) {
      croak("Missing the required parameter 'how_many_reviews' when calling get_reviews_by_company_id_and_rating");
    }

    # verify the required parameter 'last_how_many_days' is set
    unless (exists $args{'last_how_many_days'}) {
      croak("Missing the required parameter 'last_how_many_days' when calling get_reviews_by_company_id_and_rating");
    }

    # verify the required parameter 'minimum_ratings' is set
    unless (exists $args{'minimum_ratings'}) {
      croak("Missing the required parameter 'minimum_ratings' when calling get_reviews_by_company_id_and_rating");
    }

    # verify the required parameter 'maximum_ratings' is set
    unless (exists $args{'maximum_ratings'}) {
      croak("Missing the required parameter 'maximum_ratings' when calling get_reviews_by_company_id_and_rating");
    }

    # parse inputs
    my $_resource_path = '/getReviewsByCompanyIdAndRating';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json', 'application/xml');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type('application/x-www-form-urlencoded');

    # query params
    if ( exists $args{'companyid'}) {
        $query_params->{'companyid'} = $self->{api_client}->to_query_value($args{'companyid'});
    }

    # query params
    if ( exists $args{'how_many_reviews'}) {
        $query_params->{'howManyReviews'} = $self->{api_client}->to_query_value($args{'how_many_reviews'});
    }

    # query params
    if ( exists $args{'last_how_many_days'}) {
        $query_params->{'lastHowManyDays'} = $self->{api_client}->to_query_value($args{'last_how_many_days'});
    }

    # query params
    if ( exists $args{'minimum_ratings'}) {
        $query_params->{'minimumRatings'} = $self->{api_client}->to_query_value($args{'minimum_ratings'});
    }

    # query params
    if ( exists $args{'maximum_ratings'}) {
        $query_params->{'maximumRatings'} = $self->{api_client}->to_query_value($args{'maximum_ratings'});
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(api_key )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ARRAY[Review]', $response);
    return $_response_object;
}

#
# get_reviews_by_company_id_and_review_site
#
# Get X last reviews less than X days old of a review site of a company
# 
# @param string $companyid Company ID (required)
# @param string $how_many_reviews How many reviews (required)
# @param string $last_how_many_days How many days back (required)
# @param string $reviews_site Review site name (required)
{
    my $params = {
    'companyid' => {
        data_type => 'string',
        description => 'Company ID',
        required => '1',
    },
    'how_many_reviews' => {
        data_type => 'string',
        description => 'How many reviews',
        required => '1',
    },
    'last_how_many_days' => {
        data_type => 'string',
        description => 'How many days back',
        required => '1',
    },
    'reviews_site' => {
        data_type => 'string',
        description => 'Review site name',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'get_reviews_by_company_id_and_review_site' } = { 
    	summary => 'Get X last reviews less than X days old of a review site of a company',
        params => $params,
        returns => 'ARRAY[Review]',
        };
}
# @return ARRAY[Review]
#
sub get_reviews_by_company_id_and_review_site {
    my ($self, %args) = @_;

    # verify the required parameter 'companyid' is set
    unless (exists $args{'companyid'}) {
      croak("Missing the required parameter 'companyid' when calling get_reviews_by_company_id_and_review_site");
    }

    # verify the required parameter 'how_many_reviews' is set
    unless (exists $args{'how_many_reviews'}) {
      croak("Missing the required parameter 'how_many_reviews' when calling get_reviews_by_company_id_and_review_site");
    }

    # verify the required parameter 'last_how_many_days' is set
    unless (exists $args{'last_how_many_days'}) {
      croak("Missing the required parameter 'last_how_many_days' when calling get_reviews_by_company_id_and_review_site");
    }

    # verify the required parameter 'reviews_site' is set
    unless (exists $args{'reviews_site'}) {
      croak("Missing the required parameter 'reviews_site' when calling get_reviews_by_company_id_and_review_site");
    }

    # parse inputs
    my $_resource_path = '/getReviewsByCompanyIDAndReviewSite';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json', 'application/xml');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type('application/x-www-form-urlencoded');

    # query params
    if ( exists $args{'companyid'}) {
        $query_params->{'companyid'} = $self->{api_client}->to_query_value($args{'companyid'});
    }

    # query params
    if ( exists $args{'how_many_reviews'}) {
        $query_params->{'howManyReviews'} = $self->{api_client}->to_query_value($args{'how_many_reviews'});
    }

    # query params
    if ( exists $args{'last_how_many_days'}) {
        $query_params->{'lastHowManyDays'} = $self->{api_client}->to_query_value($args{'last_how_many_days'});
    }

    # query params
    if ( exists $args{'reviews_site'}) {
        $query_params->{'reviewsSite'} = $self->{api_client}->to_query_value($args{'reviews_site'});
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(api_key )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ARRAY[Review]', $response);
    return $_response_object;
}

#
# get_reviews_by_company_id_rating_and_review_site
#
# Get X last reviews that equal or over X stars of a review site of a company
# 
# @param string $companyid Company ID (required)
# @param string $how_many_reviews How many reviews (required)
# @param string $minimum_ratings Minimum review rating (reviews that are equal or over minimumRatings stars) (required)
# @param string $reviews_site Review site name (required)
{
    my $params = {
    'companyid' => {
        data_type => 'string',
        description => 'Company ID',
        required => '1',
    },
    'how_many_reviews' => {
        data_type => 'string',
        description => 'How many reviews',
        required => '1',
    },
    'minimum_ratings' => {
        data_type => 'string',
        description => 'Minimum review rating (reviews that are equal or over minimumRatings stars)',
        required => '1',
    },
    'reviews_site' => {
        data_type => 'string',
        description => 'Review site name',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'get_reviews_by_company_id_rating_and_review_site' } = { 
    	summary => 'Get X last reviews that equal or over X stars of a review site of a company',
        params => $params,
        returns => 'ARRAY[Review]',
        };
}
# @return ARRAY[Review]
#
sub get_reviews_by_company_id_rating_and_review_site {
    my ($self, %args) = @_;

    # verify the required parameter 'companyid' is set
    unless (exists $args{'companyid'}) {
      croak("Missing the required parameter 'companyid' when calling get_reviews_by_company_id_rating_and_review_site");
    }

    # verify the required parameter 'how_many_reviews' is set
    unless (exists $args{'how_many_reviews'}) {
      croak("Missing the required parameter 'how_many_reviews' when calling get_reviews_by_company_id_rating_and_review_site");
    }

    # verify the required parameter 'minimum_ratings' is set
    unless (exists $args{'minimum_ratings'}) {
      croak("Missing the required parameter 'minimum_ratings' when calling get_reviews_by_company_id_rating_and_review_site");
    }

    # verify the required parameter 'reviews_site' is set
    unless (exists $args{'reviews_site'}) {
      croak("Missing the required parameter 'reviews_site' when calling get_reviews_by_company_id_rating_and_review_site");
    }

    # parse inputs
    my $_resource_path = '/getReviewsByCompanyIDRatingAndReviewSite';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json', 'application/xml');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type('application/x-www-form-urlencoded');

    # query params
    if ( exists $args{'companyid'}) {
        $query_params->{'companyid'} = $self->{api_client}->to_query_value($args{'companyid'});
    }

    # query params
    if ( exists $args{'how_many_reviews'}) {
        $query_params->{'howManyReviews'} = $self->{api_client}->to_query_value($args{'how_many_reviews'});
    }

    # query params
    if ( exists $args{'minimum_ratings'}) {
        $query_params->{'minimumRatings'} = $self->{api_client}->to_query_value($args{'minimum_ratings'});
    }

    # query params
    if ( exists $args{'reviews_site'}) {
        $query_params->{'reviewsSite'} = $self->{api_client}->to_query_value($args{'reviews_site'});
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(api_key )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ARRAY[Review]', $response);
    return $_response_object;
}

#
# get_reviews_by_user_name
#
# Get X last reviews less than X days old of an account
# 
# @param string $username User Name or Email address (required)
# @param string $how_many_reviews How many reviews (required)
# @param string $last_how_many_days How many days back (required)
{
    my $params = {
    'username' => {
        data_type => 'string',
        description => 'User Name or Email address',
        required => '1',
    },
    'how_many_reviews' => {
        data_type => 'string',
        description => 'How many reviews',
        required => '1',
    },
    'last_how_many_days' => {
        data_type => 'string',
        description => 'How many days back',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'get_reviews_by_user_name' } = { 
    	summary => 'Get X last reviews less than X days old of an account',
        params => $params,
        returns => 'ARRAY[Review]',
        };
}
# @return ARRAY[Review]
#
sub get_reviews_by_user_name {
    my ($self, %args) = @_;

    # verify the required parameter 'username' is set
    unless (exists $args{'username'}) {
      croak("Missing the required parameter 'username' when calling get_reviews_by_user_name");
    }

    # verify the required parameter 'how_many_reviews' is set
    unless (exists $args{'how_many_reviews'}) {
      croak("Missing the required parameter 'how_many_reviews' when calling get_reviews_by_user_name");
    }

    # verify the required parameter 'last_how_many_days' is set
    unless (exists $args{'last_how_many_days'}) {
      croak("Missing the required parameter 'last_how_many_days' when calling get_reviews_by_user_name");
    }

    # parse inputs
    my $_resource_path = '/getReviewsByUserName';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json', 'application/xml');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type('application/x-www-form-urlencoded');

    # query params
    if ( exists $args{'username'}) {
        $query_params->{'username'} = $self->{api_client}->to_query_value($args{'username'});
    }

    # query params
    if ( exists $args{'how_many_reviews'}) {
        $query_params->{'howManyReviews'} = $self->{api_client}->to_query_value($args{'how_many_reviews'});
    }

    # query params
    if ( exists $args{'last_how_many_days'}) {
        $query_params->{'lastHowManyDays'} = $self->{api_client}->to_query_value($args{'last_how_many_days'});
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(api_key )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ARRAY[Review]', $response);
    return $_response_object;
}

#
# get_reviews_by_user_name_and_rating
#
# Get X last reviews that equal or over X stars of an account
# 
# @param string $username User Name or Email address (required)
# @param string $how_many_reviews How many reviews (required)
# @param string $last_how_many_days How many days back (required)
# @param string $minimum_ratings Minimum review rating (reviews that are equal or over minimumRatings stars) (required)
{
    my $params = {
    'username' => {
        data_type => 'string',
        description => 'User Name or Email address',
        required => '1',
    },
    'how_many_reviews' => {
        data_type => 'string',
        description => 'How many reviews',
        required => '1',
    },
    'last_how_many_days' => {
        data_type => 'string',
        description => 'How many days back',
        required => '1',
    },
    'minimum_ratings' => {
        data_type => 'string',
        description => 'Minimum review rating (reviews that are equal or over minimumRatings stars)',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'get_reviews_by_user_name_and_rating' } = { 
    	summary => 'Get X last reviews that equal or over X stars of an account',
        params => $params,
        returns => 'ARRAY[Review]',
        };
}
# @return ARRAY[Review]
#
sub get_reviews_by_user_name_and_rating {
    my ($self, %args) = @_;

    # verify the required parameter 'username' is set
    unless (exists $args{'username'}) {
      croak("Missing the required parameter 'username' when calling get_reviews_by_user_name_and_rating");
    }

    # verify the required parameter 'how_many_reviews' is set
    unless (exists $args{'how_many_reviews'}) {
      croak("Missing the required parameter 'how_many_reviews' when calling get_reviews_by_user_name_and_rating");
    }

    # verify the required parameter 'last_how_many_days' is set
    unless (exists $args{'last_how_many_days'}) {
      croak("Missing the required parameter 'last_how_many_days' when calling get_reviews_by_user_name_and_rating");
    }

    # verify the required parameter 'minimum_ratings' is set
    unless (exists $args{'minimum_ratings'}) {
      croak("Missing the required parameter 'minimum_ratings' when calling get_reviews_by_user_name_and_rating");
    }

    # parse inputs
    my $_resource_path = '/getReviewsByUserNameAndRating';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json', 'application/xml');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type('application/x-www-form-urlencoded');

    # query params
    if ( exists $args{'username'}) {
        $query_params->{'username'} = $self->{api_client}->to_query_value($args{'username'});
    }

    # query params
    if ( exists $args{'how_many_reviews'}) {
        $query_params->{'howManyReviews'} = $self->{api_client}->to_query_value($args{'how_many_reviews'});
    }

    # query params
    if ( exists $args{'last_how_many_days'}) {
        $query_params->{'lastHowManyDays'} = $self->{api_client}->to_query_value($args{'last_how_many_days'});
    }

    # query params
    if ( exists $args{'minimum_ratings'}) {
        $query_params->{'minimumRatings'} = $self->{api_client}->to_query_value($args{'minimum_ratings'});
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(api_key )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ARRAY[Review]', $response);
    return $_response_object;
}

#
# get_reviews_by_user_name_and_review_site
#
# Get X last reviews less than X days old of a review site of an account
# 
# @param string $username User Name or Email address (required)
# @param string $how_many_reviews How many reviews (required)
# @param string $last_how_many_days How many days back (required)
# @param string $reviews_site Review site name (required)
{
    my $params = {
    'username' => {
        data_type => 'string',
        description => 'User Name or Email address',
        required => '1',
    },
    'how_many_reviews' => {
        data_type => 'string',
        description => 'How many reviews',
        required => '1',
    },
    'last_how_many_days' => {
        data_type => 'string',
        description => 'How many days back',
        required => '1',
    },
    'reviews_site' => {
        data_type => 'string',
        description => 'Review site name',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'get_reviews_by_user_name_and_review_site' } = { 
    	summary => 'Get X last reviews less than X days old of a review site of an account',
        params => $params,
        returns => 'ARRAY[Review]',
        };
}
# @return ARRAY[Review]
#
sub get_reviews_by_user_name_and_review_site {
    my ($self, %args) = @_;

    # verify the required parameter 'username' is set
    unless (exists $args{'username'}) {
      croak("Missing the required parameter 'username' when calling get_reviews_by_user_name_and_review_site");
    }

    # verify the required parameter 'how_many_reviews' is set
    unless (exists $args{'how_many_reviews'}) {
      croak("Missing the required parameter 'how_many_reviews' when calling get_reviews_by_user_name_and_review_site");
    }

    # verify the required parameter 'last_how_many_days' is set
    unless (exists $args{'last_how_many_days'}) {
      croak("Missing the required parameter 'last_how_many_days' when calling get_reviews_by_user_name_and_review_site");
    }

    # verify the required parameter 'reviews_site' is set
    unless (exists $args{'reviews_site'}) {
      croak("Missing the required parameter 'reviews_site' when calling get_reviews_by_user_name_and_review_site");
    }

    # parse inputs
    my $_resource_path = '/getReviewsByUserNameAndReviewSite';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json', 'application/xml');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type('application/x-www-form-urlencoded');

    # query params
    if ( exists $args{'username'}) {
        $query_params->{'username'} = $self->{api_client}->to_query_value($args{'username'});
    }

    # query params
    if ( exists $args{'how_many_reviews'}) {
        $query_params->{'howManyReviews'} = $self->{api_client}->to_query_value($args{'how_many_reviews'});
    }

    # query params
    if ( exists $args{'last_how_many_days'}) {
        $query_params->{'lastHowManyDays'} = $self->{api_client}->to_query_value($args{'last_how_many_days'});
    }

    # query params
    if ( exists $args{'reviews_site'}) {
        $query_params->{'reviewsSite'} = $self->{api_client}->to_query_value($args{'reviews_site'});
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(api_key )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ARRAY[Review]', $response);
    return $_response_object;
}

#
# get_reviews_by_user_name_rating_and_review_site
#
# Get X last reviews that equal or over X stars of a review site of an account
# 
# @param string $username User Name or Email address (required)
# @param string $how_many_reviews How many reviews (required)
# @param string $minimum_ratings Minimum review rating (reviews that are equal or over minimumRatings stars) (required)
# @param string $reviews_site Review site name (required)
{
    my $params = {
    'username' => {
        data_type => 'string',
        description => 'User Name or Email address',
        required => '1',
    },
    'how_many_reviews' => {
        data_type => 'string',
        description => 'How many reviews',
        required => '1',
    },
    'minimum_ratings' => {
        data_type => 'string',
        description => 'Minimum review rating (reviews that are equal or over minimumRatings stars)',
        required => '1',
    },
    'reviews_site' => {
        data_type => 'string',
        description => 'Review site name',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'get_reviews_by_user_name_rating_and_review_site' } = { 
    	summary => 'Get X last reviews that equal or over X stars of a review site of an account',
        params => $params,
        returns => 'ARRAY[Review]',
        };
}
# @return ARRAY[Review]
#
sub get_reviews_by_user_name_rating_and_review_site {
    my ($self, %args) = @_;

    # verify the required parameter 'username' is set
    unless (exists $args{'username'}) {
      croak("Missing the required parameter 'username' when calling get_reviews_by_user_name_rating_and_review_site");
    }

    # verify the required parameter 'how_many_reviews' is set
    unless (exists $args{'how_many_reviews'}) {
      croak("Missing the required parameter 'how_many_reviews' when calling get_reviews_by_user_name_rating_and_review_site");
    }

    # verify the required parameter 'minimum_ratings' is set
    unless (exists $args{'minimum_ratings'}) {
      croak("Missing the required parameter 'minimum_ratings' when calling get_reviews_by_user_name_rating_and_review_site");
    }

    # verify the required parameter 'reviews_site' is set
    unless (exists $args{'reviews_site'}) {
      croak("Missing the required parameter 'reviews_site' when calling get_reviews_by_user_name_rating_and_review_site");
    }

    # parse inputs
    my $_resource_path = '/getReviewsByUserNameRatingAndReviewSite';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json', 'application/xml');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type('application/x-www-form-urlencoded');

    # query params
    if ( exists $args{'username'}) {
        $query_params->{'username'} = $self->{api_client}->to_query_value($args{'username'});
    }

    # query params
    if ( exists $args{'how_many_reviews'}) {
        $query_params->{'howManyReviews'} = $self->{api_client}->to_query_value($args{'how_many_reviews'});
    }

    # query params
    if ( exists $args{'minimum_ratings'}) {
        $query_params->{'minimumRatings'} = $self->{api_client}->to_query_value($args{'minimum_ratings'});
    }

    # query params
    if ( exists $args{'reviews_site'}) {
        $query_params->{'reviewsSite'} = $self->{api_client}->to_query_value($args{'reviews_site'});
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(api_key )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ARRAY[Review]', $response);
    return $_response_object;
}

#
# post_comment_on_review
#
# Comment on a Feedback / Review
# 
# @param string $reviewid Review ID (required)
# @param string $commenttext Comment Text  (required)
{
    my $params = {
    'reviewid' => {
        data_type => 'string',
        description => 'Review ID',
        required => '1',
    },
    'commenttext' => {
        data_type => 'string',
        description => 'Comment Text ',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'post_comment_on_review' } = { 
    	summary => 'Comment on a Feedback / Review',
        params => $params,
        returns => undef,
        };
}
# @return void
#
sub post_comment_on_review {
    my ($self, %args) = @_;

    # verify the required parameter 'reviewid' is set
    unless (exists $args{'reviewid'}) {
      croak("Missing the required parameter 'reviewid' when calling post_comment_on_review");
    }

    # verify the required parameter 'commenttext' is set
    unless (exists $args{'commenttext'}) {
      croak("Missing the required parameter 'commenttext' when calling post_comment_on_review");
    }

    # parse inputs
    my $_resource_path = '/postCommentOnReview';

    my $_method = 'POST';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json', 'application/xml');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type('application/x-www-form-urlencoded');

    # form params
    if ( exists $args{'reviewid'} ) {
                $form_params->{'reviewid'} = $self->{api_client}->to_form_value($args{'reviewid'});
    }
    
    # form params
    if ( exists $args{'commenttext'} ) {
                $form_params->{'commenttext'} = $self->{api_client}->to_form_value($args{'commenttext'});
    }
    
    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(api_key )];

    # make the API Call
    $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    return;
}

1;
