=begin comment

Reputation CRM API

Move your app forward with the Reputation CRM API  To get your `API key`, visit [Reputation CRM](https://reputationcrm.com/settings/index/Reputation-Builder)  Your API Key can be found in Settings -> Reputation Builder -> Reputation Builder -> API Tab   [Download API SDK](https://reputationcrm.com/developers/documentation/v2/downloads)  [API Explorer](https://reputationcrm.com/developers/documentation/v2/explorer/) 

OpenAPI spec version: 2.0.2
Contact: support@reputationcrm.com
Generated by: https://github.com/swagger-api/swagger-codegen.git

=end comment

=cut

#
# NOTE: This class is auto generated by the swagger code generator program. 
# Do not edit the class manually.
# Ref: https://github.com/swagger-api/swagger-codegen
#
package WWW::SwaggerClient::ReviewsStatsApi;

require 5.6.0;
use strict;
use warnings;
use utf8; 
use Exporter;
use Carp qw( croak );
use Log::Any qw($log);

use WWW::SwaggerClient::ApiClient;

use base "Class::Data::Inheritable";

__PACKAGE__->mk_classdata('method_documentation' => {});

sub new {
    my $class = shift;
    my $api_client;

    if ($_[0] && ref $_[0] && ref $_[0] eq 'WWW::SwaggerClient::ApiClient' ) {
        $api_client = $_[0];
    } else {
        $api_client = WWW::SwaggerClient::ApiClient->new(@_);
    }

    bless { api_client => $api_client }, $class;

}


#
# get_number_of_reviews_posted_in_last_days_by_company_id
#
# Get total reviews received for each review site
# 
# @param string $companyid Company ID (required)
# @param string $last_how_many_days Last how many days (required)
{
    my $params = {
    'companyid' => {
        data_type => 'string',
        description => 'Company ID',
        required => '1',
    },
    'last_how_many_days' => {
        data_type => 'string',
        description => 'Last how many days',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'get_number_of_reviews_posted_in_last_days_by_company_id' } = { 
    	summary => 'Get total reviews received for each review site',
        params => $params,
        returns => 'ARRAY[ReviewSitesReviewCount]',
        };
}
# @return ARRAY[ReviewSitesReviewCount]
#
sub get_number_of_reviews_posted_in_last_days_by_company_id {
    my ($self, %args) = @_;

    # verify the required parameter 'companyid' is set
    unless (exists $args{'companyid'}) {
      croak("Missing the required parameter 'companyid' when calling get_number_of_reviews_posted_in_last_days_by_company_id");
    }

    # verify the required parameter 'last_how_many_days' is set
    unless (exists $args{'last_how_many_days'}) {
      croak("Missing the required parameter 'last_how_many_days' when calling get_number_of_reviews_posted_in_last_days_by_company_id");
    }

    # parse inputs
    my $_resource_path = '/getNumberOfReviewsPostedInLastDaysByCompanyId';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json', 'application/xml');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type('application/x-www-form-urlencoded');

    # query params
    if ( exists $args{'companyid'}) {
        $query_params->{'companyid'} = $self->{api_client}->to_query_value($args{'companyid'});
    }

    # query params
    if ( exists $args{'last_how_many_days'}) {
        $query_params->{'lastHowManyDays'} = $self->{api_client}->to_query_value($args{'last_how_many_days'});
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(api_key )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ARRAY[ReviewSitesReviewCount]', $response);
    return $_response_object;
}

#
# get_number_of_reviews_required_to_achieve5_star_by_company_id
#
# Get for ALL Review Sites the number of 5-star Feedback / Reviews needed to achieve a 5-star Customer Experience 
# 
# @param string $companyid Company ID (required)
{
    my $params = {
    'companyid' => {
        data_type => 'string',
        description => 'Company ID',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'get_number_of_reviews_required_to_achieve5_star_by_company_id' } = { 
    	summary => 'Get for ALL Review Sites the number of 5-star Feedback / Reviews needed to achieve a 5-star Customer Experience ',
        params => $params,
        returns => 'ARRAY[ReviewSitesReviewCount]',
        };
}
# @return ARRAY[ReviewSitesReviewCount]
#
sub get_number_of_reviews_required_to_achieve5_star_by_company_id {
    my ($self, %args) = @_;

    # verify the required parameter 'companyid' is set
    unless (exists $args{'companyid'}) {
      croak("Missing the required parameter 'companyid' when calling get_number_of_reviews_required_to_achieve5_star_by_company_id");
    }

    # parse inputs
    my $_resource_path = '/getNumberOfReviewsRequiredToAchieve5StarByCompanyId';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json', 'application/xml');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type('application/x-www-form-urlencoded');

    # query params
    if ( exists $args{'companyid'}) {
        $query_params->{'companyid'} = $self->{api_client}->to_query_value($args{'companyid'});
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(api_key )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ARRAY[ReviewSitesReviewCount]', $response);
    return $_response_object;
}

#
# get_overall_rating_and_review_count_for_platform_reviews_by_company_id
#
# Get The Overall Rating and Total Review Count of a Company / Location for platform collected reviews  
# 
# @param string $companyid Company ID (required)
{
    my $params = {
    'companyid' => {
        data_type => 'string',
        description => 'Company ID',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'get_overall_rating_and_review_count_for_platform_reviews_by_company_id' } = { 
    	summary => 'Get The Overall Rating and Total Review Count of a Company / Location for platform collected reviews  ',
        params => $params,
        returns => 'ARRAY[OverallRatingAndReviewCount]',
        };
}
# @return ARRAY[OverallRatingAndReviewCount]
#
sub get_overall_rating_and_review_count_for_platform_reviews_by_company_id {
    my ($self, %args) = @_;

    # verify the required parameter 'companyid' is set
    unless (exists $args{'companyid'}) {
      croak("Missing the required parameter 'companyid' when calling get_overall_rating_and_review_count_for_platform_reviews_by_company_id");
    }

    # parse inputs
    my $_resource_path = '/getOverallRatingAndReviewCountForPlatformReviewsByCompanyId';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json', 'application/xml');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type('application/x-www-form-urlencoded');

    # query params
    if ( exists $args{'companyid'}) {
        $query_params->{'companyid'} = $self->{api_client}->to_query_value($args{'companyid'});
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(api_key )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ARRAY[OverallRatingAndReviewCount]', $response);
    return $_response_object;
}

#
# get_overall_rating_for_each_review_site_by_company_id
#
# Get overall rating for each review site
# 
# @param string $companyid Company ID (required)
{
    my $params = {
    'companyid' => {
        data_type => 'string',
        description => 'Company ID',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'get_overall_rating_for_each_review_site_by_company_id' } = { 
    	summary => 'Get overall rating for each review site',
        params => $params,
        returns => 'ARRAY[ReviewSitesRating]',
        };
}
# @return ARRAY[ReviewSitesRating]
#
sub get_overall_rating_for_each_review_site_by_company_id {
    my ($self, %args) = @_;

    # verify the required parameter 'companyid' is set
    unless (exists $args{'companyid'}) {
      croak("Missing the required parameter 'companyid' when calling get_overall_rating_for_each_review_site_by_company_id");
    }

    # parse inputs
    my $_resource_path = '/getOverallRatingForEachReviewSiteByCompanyId';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json', 'application/xml');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type('application/x-www-form-urlencoded');

    # query params
    if ( exists $args{'companyid'}) {
        $query_params->{'companyid'} = $self->{api_client}->to_query_value($args{'companyid'});
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(api_key )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ARRAY[ReviewSitesRating]', $response);
    return $_response_object;
}

#
# get_overall_rating_of_company_by_company_id
#
# Get The Overall Rating of a Company / Location / Feedback Page 
# 
# @param string $companyid Company ID (required)
{
    my $params = {
    'companyid' => {
        data_type => 'string',
        description => 'Company ID',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'get_overall_rating_of_company_by_company_id' } = { 
    	summary => 'Get The Overall Rating of a Company / Location / Feedback Page ',
        params => $params,
        returns => 'ARRAY[OverallCompanyRating]',
        };
}
# @return ARRAY[OverallCompanyRating]
#
sub get_overall_rating_of_company_by_company_id {
    my ($self, %args) = @_;

    # verify the required parameter 'companyid' is set
    unless (exists $args{'companyid'}) {
      croak("Missing the required parameter 'companyid' when calling get_overall_rating_of_company_by_company_id");
    }

    # parse inputs
    my $_resource_path = '/getOverallRatingOfCompanyByCompanyId';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json', 'application/xml');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type('application/x-www-form-urlencoded');

    # query params
    if ( exists $args{'companyid'}) {
        $query_params->{'companyid'} = $self->{api_client}->to_query_value($args{'companyid'});
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(api_key )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ARRAY[OverallCompanyRating]', $response);
    return $_response_object;
}

#
# get_overall_reputation_change_of_all_review_sites_by_company_id
#
# Get the Overall Reputation Increase / Decrease of ALL Review Sites 
# 
# @param string $companyid Company ID (required)
{
    my $params = {
    'companyid' => {
        data_type => 'string',
        description => 'Company ID',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'get_overall_reputation_change_of_all_review_sites_by_company_id' } = { 
    	summary => 'Get the Overall Reputation Increase / Decrease of ALL Review Sites ',
        params => $params,
        returns => 'ARRAY[ReviewSitesReputationChange]',
        };
}
# @return ARRAY[ReviewSitesReputationChange]
#
sub get_overall_reputation_change_of_all_review_sites_by_company_id {
    my ($self, %args) = @_;

    # verify the required parameter 'companyid' is set
    unless (exists $args{'companyid'}) {
      croak("Missing the required parameter 'companyid' when calling get_overall_reputation_change_of_all_review_sites_by_company_id");
    }

    # parse inputs
    my $_resource_path = '/getOverallReputationChangeOfAllReviewSitesByCompanyId';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json', 'application/xml');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type('application/x-www-form-urlencoded');

    # query params
    if ( exists $args{'companyid'}) {
        $query_params->{'companyid'} = $self->{api_client}->to_query_value($args{'companyid'});
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(api_key )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ARRAY[ReviewSitesReputationChange]', $response);
    return $_response_object;
}

#
# get_total_reviews_received_for_each_review_site_by_company_id
#
# Get total reviews received for each review site
# 
# @param string $companyid Company ID (required)
{
    my $params = {
    'companyid' => {
        data_type => 'string',
        description => 'Company ID',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'get_total_reviews_received_for_each_review_site_by_company_id' } = { 
    	summary => 'Get total reviews received for each review site',
        params => $params,
        returns => 'ARRAY[ReviewSitesReviewCount]',
        };
}
# @return ARRAY[ReviewSitesReviewCount]
#
sub get_total_reviews_received_for_each_review_site_by_company_id {
    my ($self, %args) = @_;

    # verify the required parameter 'companyid' is set
    unless (exists $args{'companyid'}) {
      croak("Missing the required parameter 'companyid' when calling get_total_reviews_received_for_each_review_site_by_company_id");
    }

    # parse inputs
    my $_resource_path = '/getTotalReviewsReceivedForEachReviewSiteByCompanyId';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json', 'application/xml');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type('application/x-www-form-urlencoded');

    # query params
    if ( exists $args{'companyid'}) {
        $query_params->{'companyid'} = $self->{api_client}->to_query_value($args{'companyid'});
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(api_key )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ARRAY[ReviewSitesReviewCount]', $response);
    return $_response_object;
}

1;
